/*  ************************************************************************************************
 *
 *  THIS PART WAS TAKEN FROM "Anope"!
 *
 *  Copyright (C) 2004-2009
 *      Manuel Moser (alias: shock), Email: shock@deepirc.net,
 *      Christian Liebig (alias: cLiEbiG), Email: cLiEbiG@deepirc.net
 * 
 *  ************************************************************************************************
 *
 *  Based on the original code of Epona by Lara.
 *  Based on the original code of Services by Andy Church. 
 *  Based on the original code of Anope by Daniel Engel. 
 *
 *  ************************************************************************************************
 *
 *  This program is free software; you can redistribute it and/or modify it under the terms of 
 *  the GNU General Public License as published by the Free Software Foundation; either version 3 
 *  of the License, or (at your option) any later version. 
 *
 *  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; 
 *  without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See 
 *  the GNU General Public License for more details. 
 *
 *  You should have received a copy of the GNU General Public License along with this program; 
 *  if not, see <http://www.gnu.org/licenses/>. 
 *
 *  ************************************************************************************************
 * 
 *  SVN Status Information:
 *
 *      $Rev:: 365                   $:	Rivision of last commit
 *      $Author:: shockzZ            $:	Author of last commit
 *      $Date:: 2009-11-18 17:38:07 #$:	Date of last commit
 *
 *  ************************************************************************************************  */

#ifndef ENCRYPT_H
#define ENCRYPT_H

#include "datatypes.h"

#ifdef HAVE_SYS_TYPES_H
  #include <sys/types.h>
#endif

#ifdef HAVE_SYS_STAT_H
  #include <sys/stat.h>	/* for umask() on some systems */
#endif

#ifndef _WIN32
  #include <sys/un.h>
#endif

#ifdef _WIN32
  #ifdef MODULE_COMPILE
    #define DLL __declspec( dllimport )
  #else
    #define DLL __declspec( dllexport )
  #endif
#else
  #define DLL extern
#endif

DLL void encmodule_encrypt(int32 (*func)
                        (const char *src, size_t len, char *dest, size_t size));
DLL void encmodule_encrypt_in_place(int32 (*func) (char *buf, size_t size));
DLL void encmodule_encrypt_check_len(int32 (*func) (size_t passlen, size_t bufsize));
DLL void encmodule_decrypt(int32 (*func) (const char *src, char *dest, size_t size));
DLL void encmodule_check_password(int32 (*func)
                               (const char *plaintext,
                                const char *password));
DLL void encmodule_check_encryption(char* (*func) (void));

typedef struct encryption_ {
    int32 (*encrypt)(const char *src, size_t len, char *dest, size_t size);
    int32 (*encrypt_in_place)(char *buf, size_t size);
    int32 (*encrypt_check_len)(size_t passlen, size_t bufsize);
    int32 (*decrypt)(const char *src, char *dest, size_t size);
    int32 (*check_password)(const char *plaintext, const char *password);
    char* (*check_encryption)(void);
} Encryption;
#endif
