#Simple Languagefile Comparison by seraphim 09
#For errors hit your developer or shoot your supporter or computer.
#Usage:
#perl abc.pl -e <sourcefile> catches all "chars" from the file and prints them to makefile.incexports.win32
#perl abc.pl -c <referencefile> <file to compare with> <outputlog>
if ($ARGV[0] =~ m/^-e\z/) {
	do_export($ARGV[1]) if ($ARGV[1]);
} elsif (($ARGV[0] =~ m/^-c\z/) && ($ARGV[3])) {
	#print "Checking $ARGV[2] with $ARGV[1] as reference ($ARGV[3] contains log!)...\n";
	do_check($ARGV[1], $ARGV[2], $ARGV[3]);
	#print "Done...\n";
};
sub do_check {
	use Fcntl qw/ :seek /;
	my $reffile = $_[0];
	my $compfile = $_[1];
	my $logfile = $_[2];
	my $clogfile = 'log.c';
	open(my $ref, '<' . $reffile);
	open(my $comp, '<' . $compfile);
	open (my $out, '>' . $logfile);
	open (my $clog, '>>' . $clogfile);
	select $out;
	$| = 1;
	my @reflist;
	while (my $line = <$ref>) {		
		chomp($line);
		if ($line =~ m/^(char .*\[\]\=).*\z/) {
			push(@reflist,$1);
		};
	};
	my $first = 0;
	foreach my $refentry (@reflist) {
		#print "$refentry\n";
		my $reg1 = quotemeta($refentry);
		my $reg = qr/^$reg1.*\z/;
		my $char = $refentry;
		$char =~ s/^char //;
		$char =~ s/\[\]\=.*\z//;
		seek($comp, 0, SEEK_SET);
		my $check = 0;
		while (my $cline = <$comp>) {
			chomp($cline);
			if ($cline =~ m/$reg/) {
				$check++;
				next;
			};
		};
		if ($check == 0) {
			print $clog "$compfile - MISSING PARAMETER: $char\n";
			if ($first == 0) {
				print $out "EXPORTS=";
				print $out " /export:$char ";
				$first++;
			} else {
				print $out "\\";
				print $out "\n";
				print $out "/export:$char ";
			};
		};
	};
	close($comp);
	close($list);
	if (-z $out) {
		close($out);
		unlink $logfile;
	};
	if (-z $clog) {
		close($clog);
		unlink $clogfile;
	};
};
sub do_export {
	my $source = $_[0];
	open(my $src, '<' . $source);
	open (my $out, '>langs.def');
	print $out "EXPORTS=";
	while (my $line = <$src>) {
		chomp($line);
		if ($line =~ m/^char (.*)\[\]\=.*\z/) {
			my $char = $1;
			print $out "$char\n";
			};
		};
	};
};