/*  ************************************************************************************************
 *
 *  Copyright (C) 2004-2009
 *      Manuel Moser (alias: shock), Email: shock@deepirc.net
 *      Christian Liebig (alias: cLiEbiG), Email: cLiEbiG@deepirc.net
 * 
 *  ************************************************************************************************
 *
 *  Please read COPYING and README for further details.
 *  Based on the original code of Services by Andy Church. 
 *
 *  This program is free software; you can redistribute it and/or modify it under the terms of 
 *  the GNU General Public License as published by the Free Software Foundation; either version 3 
 *  of the License, or (at your option) any later version. 
 *
 *  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; 
 *  without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See 
 *  the GNU General Public License for more details. 
 *
 *  You should have received a copy of the GNU General Public License along with this program; 
 *  if not, see <http://www.gnu.org/licenses/>. 
 *
 *  ************************************************************************************************
 *
 *  This is "Project orion" - coded for DeepIRC @ www.deepirc.net
 *  It was coded since no one was able to come up with Live MySQL - able - Services.
 *  This Services are based on Andy Church (Epona, Anope)
 * 
 *  Credits: cLiEbiG and shock (myself)
 *
 *  ************************************************************************************************
 * 
 *  SVN Status Information:
 *
 *      $Rev:: 370                   $:	Rivision of last commit
 *      $Author:: shockzZ            $:	Author of last commit
 *      $Date:: 2009-11-26 17:17:04 #$:	Date of last commit
 *
 *  ************************************************************************************************
 * 
 *  The following part is important for the Doxygen Documentation:
 */
 /** @mainpage Developers-Guide
 *
 * @section intro_sec Introduction
 *
 * ###################################################################################<br>
 * # Introduction<br>
 * #<br>
 * # (C) Manuel Moser (alias: shock), Email: shock@deepirc.net<br>
 * # (C) Christian Liebig (alias: cLiEbiG), Email: cLiEbiG@deepirc.net<br>
 * #<br>
 * # This program is copyright by the GNU General Public License (GPL)<br>
 * # (C)2008 vers. 2.8<br>
 * #<br>
 * ###################################################################################<br>
 * #<br>
 * # This is "Project orion" - coded for DeepIRC @ www.deepirc.net<br>
 * # It was coded because noone was able to come up with "Live MySQL" - able - Services.<br>
 * # This Services are based on Andy Church (Epona, Anope)<br>
 * # <br>
 * # Credits: cLiEbiG and shock (myself)<br>
 * #<br>
 * ###################################################################################<br>
 * # Please read COPYING and README for further details.<br>
 * #<br>
 * # Based on the original code of Services by Andy Church.<br>
 * #<br>
 * # This program is free software; you can redistribute it and/or modify<br>
 * # it under the terms of the GNU General Public License as published by<br>
 * # the Free Software Foundation; either version 2 of the License, or<br>
 * # (at your option) any later version.<br>
 * #<br>
 * # This program is distributed in the hope that it will be useful,<br>
 * # but WITHOUT ANY WARRANTY; without even the implied warranty of<br>
 * # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the<br>
 * # GNU General Public License for more details.<br>
 * #<br>
 * # You should have received a copy of the GNU General Public License<br>
 * # along with this program (see the file COPYING); if not, write to the<br>
 * # Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.<br>
 * ###################################################################################<br>
 *<br>
 * @section install_sec Installation
 *<br>
 * @subsection step1 Step 1: Directory
 * Unpack the services to a directory of your choice (If you read this, you even<br>
 * did that, so continue with Step 2.)<br>
 * <br>
 * @subsection step2 Step 2: ./Config
 * Install them by using "./Config" - just type "./Config" in your choosen directory<br>
 * (set chmod +x Config, if it's not an executeable by now)<br>
 * Just follow the instructions after ./Config - you have to run "make" afterwards - just type "make"<br>
 * Now you should install your services to your choosen directory by typing "make install"<br>
 * <br>
 * @subsection step3 Step 3: example.conf
 * Configure them by using the example.conf (just rename it to "services.conf")<br>
 * Afterwards edit it with (nano, mc, vi .. or whatever).<br>
 * Make sure that you use the mysql.sock path instead of the port<br>
 * (leave the host as "localhost" - you shouldn't run it with a remote Database!)<br>
 * <br>
 * @subsection step4 Step 4: tables.sql
 * You should now set up the Database which is easy, because you only have to load<br>
 * the given Database file "tables.sql"<br>
 * (just create the DB - make sure that you use the same name for the DB as the one<br>
 * you put into the services.conf file - and load the "tables.sql" to that Database.<br>
 * <br>
 * @subsection step5 Step 5: Modul configuration
 * If you want you are now able to configure the modules which should be loaded on startup,<br>
 * therefor each client has it's own smart .conf file (only for client specific settings)<br>
 * and a *.modul file.<br>
 * If you don't want to use a modul (which was given there) just use the "\#" character<br>
 * like that "\#list" in the Q.modul.<br>
 * (That is only possible if you disabled AutoRegonizeModules in the services.conf! If it's enabled<br>
 * orion automatically loads all modules from the "ModuleDirectory"!)<br>
 * <br>
 * You are also able to configure the clients which should be used, by using the modules.conf<br>
 * file. There you are able to edit the clients by again putting "\#" before thier names.<br>
 * <br>
 * @subsection step6 Step 6: InspIRCd configuration
 * IF YOU USE InspIRCd!!<br>
 * Edit the InspIRCd config to use at least these modules (YOU HAVE TO LOAD THEM!):<br>
 * "m_chanprotect.so"<br>
 * "m_services.so"<br>
 * YOU ALSO HAVE TO ENABLE "qaprefix" !!!<br>
 * We also recommand to use these modules (if you want to run HostServ):<br>
 * "m_chghost.so"<br>
 * "m_chgident.so"<br>
 * If you don't care about using modules it would be smart to use them too:<br>
 * "m_sajoin.so"<br>
 * "m_sanick.so"<br>
 * "m_sapart.so"<br>
 * These two are optional anywayz (but would be helpful, in this version of orion and in upcoming):<br>
 * "m_chgname.so"<br>
 * "m_globops.so"<br>
 * <br>
 * @subsection step7 Step 7: StartUp
 * START them up! ;)<br>
 * <br>
 * @subsection step8 Step 8: Create ServicesRoot account
 * Register your nick / and validate if you use the email-validation system.<br>
 * After your nick was added successful go back to terminal again,<br>
 * then execute "./services -giveroot YOURNICK"<br>
 * Now you should have SRA access (with owner levels).<br>
 * <br>
 * NOTE: DON'T FORGET TO SET SRA's THE NOEXPIRE-OPTION!!!!<br>
 * <br>
 * @subsection step9 Step 9: Have fun
 * Have fun ;) - greetings shock, cLiEbiG, Ally feat. CoolDuke (Ex-DeepIRC) from DeepIRC<br>
 * <br>
 * <br>
 * @section modul_sec Modules
 * If you change some modules on your own, or add new ones then use "make update"<br>
 * and rehash orion from the console afterwards - with using "./services -rehash"<br>
 * <br>
 * Please keep in mind that we CAN'T SUPPORT MODIFIED MODULES!<br>
 * <br>
 * <br>
 * @section support_sec Support
 * If you need some professional support please visit us on IRC @ irc.deepirc.net 6667<br>
 * Channel \#orion (don't pm please - give our Real-life a chance too ;)<br>
 * <br>
 * <br>
 * @section bugs_sec Bugs
 * You want to report a bug?<br>
 * Then please visit us on IRC @ irc.deepirc.net 6667 \#orion<br>
 * <br>
 * We are interested in killing all bugs, so feel free to report them<br>
 * In that case you are even allowed to pm ChannelOps ;)<br>
 *  
 */
/*  ************************************************************************************************  */
 
#include "sysconf.h"
#include "datatypes.h"
#include "global.h"
#include "modules.h"
#include "services.h"
#include "osocket.h"
#include "webform.h"

#include <sys/types.h>
#include <stdlib.h>
#include <signal.h>
#include <string.h>

#ifndef USE_THREADS
  #ifndef _WIN32
    #include <fcntl.h>
    #include <netinet/in.h>
    #include <arpa/inet.h>
  #endif
#endif

/** Functions **/
void sighandler(int signum);
#ifndef _WIN32
  extern int kill(pid_t pid, int sig);
#endif

/******** Global variables! ********/
int logchan 		= 0;             /* -logchan */
int logging 		= 0;             /* -logging (alog();)*/
int sqllogging 		= 0;             /* -sqllogging (sqllog();)*/
int readonly 		= 0;             /* -services do not accept user queries */
int dofork 			= 1;             /* -fork */
int noexpire 		= 0;
int serverid 		= 0;
int debugbylog		= 0;
/***********************************/

FILE *quotelog     = NULL;
FILE *InputLog     = NULL;
Threads *IRCThread = NULL;
int IRCSock;

/* Sockscontrol setup (better don't edit this!) */
time_t sockstartcheck 			= 0;
time_t sockendtime 				= 0;
time_t defcon_last_flood		= 0;
time_t socktimediff 			= 0;

int socks_autodefcon_status		= 0;
int socks_remember_defcon   	= 0;
int sockstatus 					= 1;

/* if you set that parameter to 1, sockscontrol will gline all clients that are connecting too fast.
    WARNING: if you set it to 1 before launching orion, sockscontrol will gline all users on the network by launching
    orion, because orion gets all client connects VERY fast by connecting and that's fast enough that it's over the limit
    so sockscontrol will act like you told him to act by a connectionflood.
*/
int sockemergency 				= 0; 

/* Global managers */
int defcon 						= 5; //don't change that digit until you launched orion.
bool noop 						= false; //Don't set it to 1 before starting orion!! - that will kill all ircoperators.
bool netinfo 					= false; 
bool DuringServerlink 			= false;
bool connected 					= false;

/* Global buffers */
char linkserver		[MAX_SERVER_LEN];
char squitmsg		[MAX_QUITMSG_LEN];
char global_target	[MAX_MESSAGE_LEN];
char testedDebugLog [300];

/* Update Times */
time_t sqldumptime        = 0;	/* Sql Dumptime - for dumping MySQL Tables (trusts) in a period of 30 minutes to the memory! */
time_t LimitRefreshTime   = 0;	/* Refresh time for channellimits (channels which are registered by Q) */
time_t ExpireCheckTime    = 0;	/* Expire timer for nicks, channels glines and some other stuff */
time_t PingCheckTime      = 0;
time_t LastNickCheck      = 0;
time_t LastUsedCheck      = 0;
time_t StayRefreshTime    = 0;
time_t TrafficCalcTime    = 0;
#ifndef THREAD_PROCESSES
time_t LastNickCheckDelay = 20;
#endif

/* Protocol structures */
Protocol IRC;					 /* Used for the IRCd Protocols! */
Protocol WebForm;				 /* Used for the WebForm Protocol! */

/* Parameters and environment */
char **my_av, **my_envp;

/* Config */
ns_conf ns_conf_l;
cs_conf cs_conf_l;
hs_conf hs_conf_l;
ms_conf ms_conf_l;
bs_conf bs_conf_l;
g_conf g_conf_l;
Q_conf Q_conf_l;
O_conf O_conf_l;
sockscontrol_conf sc_conf_l;
config_load copyconfig;

config_load *m = &copyconfig;
Q_conf *Q = &Q_conf_l;
O_conf *O = &O_conf_l;
sockscontrol_conf *SC = &sc_conf_l;
ns_conf *ns = &ns_conf_l;
cs_conf *cs = &cs_conf_l;
hs_conf *hs = &hs_conf_l;
ms_conf *ms = &ms_conf_l;
bs_conf *bs = &bs_conf_l;
g_conf *g  = &g_conf_l;
/* ********* */

/******* LEVEL changing Q<->ChanServ *******/
LevelChanging leveltable[MAX_CHANNEL_LEVELS];
/*******************************************/

#ifdef USE_THREADS
/***** Mutexes *****/
pthread_mutex_t limit_lock;
pthread_mutexattr_t limit_lock_attr;

pthread_mutex_t dlog_lock;
pthread_mutexattr_t dlog_lock_attr;

pthread_mutex_t sqllog_lock;
pthread_mutexattr_t sqllog_lock_attr;

pthread_mutex_t alog_lock;
pthread_mutexattr_t alog_lock_attr;

pthread_mutex_t mail_lock;
pthread_mutexattr_t mail_lock_attr;

pthread_mutex_t modules_read_lock;
pthread_mutexattr_t modules_read_lock_attr;

pthread_mutex_t modules_lock;
pthread_mutexattr_t modules_lock_attr;

pthread_mutex_t mysql_lock;
pthread_mutexattr_t mysql_lock_attr;

pthread_mutex_t quotelog_lock;
pthread_mutexattr_t quotelog_lock_attr;

pthread_mutex_t mysqlbuffer_lock;
pthread_mutexattr_t mysqlbuffer_lock_attr;

pthread_mutex_t users_lock;
pthread_mutexattr_t users_lock_attr;

pthread_mutex_t protocol_lock;
pthread_mutexattr_t protocol_lock_attr;

pthread_mutex_t backtrace_lock;
pthread_mutexattr_t backtrace_lock_attr;

pthread_mutex_t stays_lock;
pthread_mutexattr_t stays_lock_attr;

pthread_mutex_t substring_lock;
pthread_mutexattr_t substring_lock_attr;

pthread_mutex_t trusts_lock;
pthread_mutexattr_t trusts_lock_attr;

pthread_mutex_t trustgroups_lock;
pthread_mutexattr_t trustgroups_lock_attr;

pthread_mutex_t ulines_lock;
pthread_mutexattr_t ulines_lock_attr;

pthread_mutex_t servers_lock;
pthread_mutexattr_t servers_lock_attr;

pthread_mutex_t thread_lock;
pthread_mutexattr_t thread_lock_attr;

pthread_mutex_t globvar_lock;
pthread_mutexattr_t globvar_lock_attr;

pthread_mutex_t shconfig_lock;
pthread_mutexattr_t shconfig_lock_attr;

pthread_mutex_t languages_lock;
pthread_mutexattr_t languages_lock_attr;



pthread_mutex_t sockets_lock;
pthread_mutexattr_t sockets_lock_attr;

pthread_mutex_t sockread_lock;
pthread_mutexattr_t sockread_lock_attr;

pthread_mutex_t sockwrite_lock;
pthread_mutexattr_t sockwrite_lock_attr;

pthread_mutex_t threads_lock;
pthread_mutexattr_t threads_lock_attr;
/******************/
#endif

#ifndef USE_THREADS /* Initialize Webform variables */
/* master file descriptor list */
fd_set master;

/* temp file descriptor list for select() */
fd_set read_fds;

/* server address */
struct sockaddr_in serveraddr;

/* client address */
struct sockaddr_in clientaddr;
#endif

void do_backtrace(Threads *thread, bool show_segheader, int steps){
#ifndef _WIN32
  #ifdef HAVE_BACKTRACE
    void *array[50];
    size_t size;
    char **strings;
    int i;

    if (show_segheader) {
        dlog(thread,0,"Backtrace: Segmentation fault detected\n");
        dlog(thread,0,"Backtrace: report the following lines\n");
        
        alog(thread,"Backtrace: Segmentation fault detected\n");
        alog(thread,"Backtrace: report the following lines\n");
    }
    dlog(thread,0,"Backtrace: [%s - Project: %s] version %s\n", MAINPROJECT,PROJECTNAME,VERSION);
    alog(thread,"Backtrace: [%s - Project: %s] version %s\n", MAINPROJECT,PROJECTNAME,VERSION);
    size = backtrace(array, steps);
    strings = backtrace_symbols(array, size);
    for (i = 1; i < size; i++) {
        dlog(thread,0,"Backtrace(%d): %s\n", i, strings[i]);
        alog(thread,"Backtrace(%d): %s\n", i, strings[i]);
    }
    free(strings);
    dlog(thread,0,"Backtrace: complete\n");
    alog(thread,"Backtrace: complete\n");
  #else
    dlog(thread,0,"Backtrace: not available on this platform\n");
    alog(thread,"Backtrace: not available on this platform\n");
  #endif
#else
    dlog(thread,0,"Backtrace: not available on this windows\n");
    alog(thread,"Backtrace: not available on this windows\n");
#endif
}

/*  ************************************************************************************************  */

/* Remove our PID file. */

void remove_pidfile(void){
    remove(m->pidfilename);
}

/*  ************************************************************************************************  */

/* Create our PID file and write the PID to it. */

static void write_pidfile(void){
	char si[10];
	char *fgetstest = NULL;
	FILE *pidcheck = fopen(m->pidfilename, "r" ); // open the pidfile in read mode to check if its represented
	int pid = (int)mygetpid(); // get the pid of the currently started process
	int ppid = 0;
	
	if(pidcheck == NULL){ // if no pidfile is represented try to write one
		pidcheck = NULL;
		pidcheck = fopen(m->pidfilename, "wt" ); // open the pidfile in write mode
		fprintf(pidcheck, "%d" , pid); // put the gathered pid into the file
		fclose(pidcheck); // close the pid file
	} else { // if a pid file is represented try to read the pid from it and do the check
		fgetstest = fgets(si, 10, pidcheck);
		ppid = stoi(si);
		fclose(pidcheck);
		if(pid != ppid){ // if the pid isnt the same as saved in the pid file indicate that the services are already running and stop execution
			printf("  *  ERROR: Services are already running!\n");
			exit(0);
		}
	}
}

static void check_pidfile(void){
	char si[10];
	char *fgetstest = NULL;
	FILE *pidcheck = fopen(m->pidfilename, "r" ); // open the pidfile in read mode to check if its represented
	int pid = (int)mygetpid(); // get the pid of the currently started process
	int ppid = 0;
	
	if(pidcheck != NULL){ // if no pidfile is represented try to write one
		fgetstest = fgets(si, 10, pidcheck);
		ppid = stoi(si);
		fclose(pidcheck);
		if(pid != ppid){ // if the pid isnt the same as saved in the pid file indicate that the services are already running and stop execution
			printf("  *  ERROR: Services are already running!\n");
			exit(0);
		}
	}
}

/* Link Functions - used for connecting, starting, exiting at all */
void closelink(Threads *thread){
	close(thread->Sock);
	if(thread->Sock)
		close(thread->MSock);
	
	return;
}

void exitservices(Threads *thread){
	/* Declare variables */
	int		i = 0;
	char	langfile[50];
	deepSQL commands;

	/* Initialise variables to (NULL) */
	bzero(&langfile,sizeof(&langfile));
	bzero(&commands,sizeof(commands));

#ifdef USE_THREADS
	my_pthread_mutex_lock(&globvar_lock);
#endif
	dynclose(thread,languages[EN]);
	dynclose(thread,languages[FR]);
	dynclose(thread,languages[ES]);
	dynclose(thread,languages[IT]);
	dynclose(thread,languages[PL]);
#ifdef USE_THREADS
	my_pthread_mutex_unlock(&globvar_lock);
#endif

	commands.res    = doSelectMySQL(thread,"SELECT `service` FROM `orion_core_commands` GROUP BY `service`");
	commands.fields = mysql_num_rows(commands.res);
	for(i=0;i<commands.fields;i++){
		commands.row = mysql_fetch_row(commands.res);
		unload_modules(thread,commands.row[0]);
	}
	
	mysql_free_result_myr(commands.res);

#ifdef USE_THREADS
	my_pthread_mutex_lock(&globvar_lock);
#endif
	if(squitmsg[0] != '\0') do_squit(thread,m->servername,squitmsg);
	else{
		snprintf(squitmsg,sizeof(squitmsg),"(%s) Services are shutting down, caused by an UNKNOWN Signal",MAINPROJECT);
		do_squit(thread,m->servername,squitmsg);
    }
#ifdef USE_THREADS
	my_pthread_mutex_unlock(&globvar_lock);
#endif
	connected = 0;
	return;
}

void _orion_exit(){
	close_all_logs("\nused _orion_exit(); - Services SHUTDOWN\n");

#ifdef _WIN32
	exit(EXIT_SUCCESS);
#else
	exit(0);
#endif
	return;
}

void orion_exit(Threads *thread){
	exitservices(thread);
	closelink(thread);
	
	close_all_logs("\nused orion_exit(); - Services SHUTDOWN\n");
    
	remove_pidfile();
	_orion_exit();
	return;
}

void startservices(Threads *thread){
	//main_raw(":%s EOS",m->servername);
	if(m->GlobalOnCycleUp[0]!='\0')
		msend(thread,0,g->nick,_dynadd("$*%s",m->host),"%s",m->GlobalOnCycleUp);
	return;
}

/*  ************************************************************************************************  */

/* Parse command-line options.  Return 0 if all went well, -1 for an error
 * with an option, or 1 for -help.
 */

static int parse_options(size_t ac, char *av[])
{
    int 	i;
    char 	*s, *t;

    for (i = 1; i < ac; i++) {
        s = av[i];
        if (*s == '-') {
            s++;
            if (strcmp(s, "remote") == 0) {
                if (++i >= ac) {
                    fprintf(stderr, "-remote requires hostname[:port]\n");
                    return -1;
                }
                s = av[i];
                t = strchr(s, ':');
                if (t) {
                    *t++ = 0;
                    if (stoi(t) > 0)
                        m->port = stoi(t);
                    else {
                        fprintf(stderr,
                                "-remote: port number must be a positive integer.  Using default.");
                        return -1;
                    }
                }
                dynncpy(m->server,s,sizeof(m->server));
            } else if (strcmp(s, "name") == 0) {
                if (++i >= ac) {
                    fprintf(stderr, "-name requires a parameter\n");
                    return -1;
                }
                dynncpy(m->servername,av[i],sizeof(m->servername));
            } else if (strcmp(s, "user") == 0) {
                if (++i >= ac) {
                    fprintf(stderr, "-user requires a parameter\n");
                    return -1;
                }
                dynncpy(m->nick,av[i],sizeof(m->nick));
            } else if (strcmp(s, "host") == 0) {
                if (++i >= ac) {
                    fprintf(stderr, "-host requires a parameter\n");
                    return -1;
                }
                dynncpy(m->host,av[i],sizeof(m->host));
            } else if (strcmp(s, "log") == 0) {
                if (++i >= ac) {
                    fprintf(stderr, "-log requires a parameter\n");
                    return -1;
                }
                dynncpy(m->logfile,av[i],sizeof(m->logfile));
			} else if (strcmp(s, "debugbylog") == 0) {
                if (++i >= ac) {
                    fprintf(stderr, "-debugbylog requires a parameter\n");
                    return -1;
                }
                debugbylog = 1;
                dofork = 0;
                dynncpy(testedDebugLog,av[i],sizeof(testedDebugLog));
                InputLog = fopen(_dynadd("logs/%s",testedDebugLog),"r");
            } else if (strcmp(s, "movedb") == 0) {
                /*if (++i >= ac) {
                    fprintf(stderr, "-movedb requires a parameter (1 for BLOB and 0 for None)\n");
                    return -1;
                }
                if(stoi(av[i])<0 || stoi(av[i])>1){
                    fprintf(stderr, "-movedb unknown BLOB identifier\n");
                    return -1;
                }else{*/
					NewTData					("moveDB");
					Threads *thread = SeekThread("moveDB");
					
                	anope_to_orion(thread,1);
                	fprintf(stderr, "Data moved to your orion Datatables (StartUp with ./services)\n");
                	exit(0);
				//}
            } else if (strcmp(s, "anopetodb") == 0) {
				NewTData					("AnopeToDB");
				Threads *thread = SeekThread("AnopeToDB");
				
               	anopeFiles_to_orion(thread);
               	fprintf(stderr, "Data from db/* moved to your orion Datatables (StartUp with ./services)\n");
               	exit(0);
            } else if (strcmp(s, "giveroot") == 0) {
                if (++i >= ac) {
                    fprintf(stderr, "-giveroot requires a parameter (the nickname for SRA)\n");
                    return -1;
                }
                char nick[MAX_NICK_LEN*2];
                bzero(&nick,sizeof(nick));
				NewTData					("giveroot");
				Threads *thread = SeekThread("giveroot");
				
				mysql_connect(thread);
				mysql_real_escape_string(MYSQL_CONNECTION_HANDLE, nick, av[i], strlen(av[i]));
				
				if(stoi(mysql_sel_var(thread,"SELECT count(1) FROM `orion_ns_aliases` WHERE `nick`='%s'",nick))==1){
					Aliases aliases=sql_aliases(thread,av[i]);
					
					if(aliases.fields){
						domysql(thread,"UPDATE `orion_ns_core` SET `qlevel`='1001',`olevel`='1001',`slevel`='1001',`llevel`='1001',`rights`='4' WHERE `authnick`='%s'",aliases.authnick);
						fprintf(stderr, "Nick: %s - is now a Services Root Administrator (with services owner levels) ...\n",av[i]);
					}else
                		fprintf(stderr, "Nick not existing, or something went wrong in the registration process ...\n");
				}else
                	fprintf(stderr, "Nick not existing ...\n");
                	
                mysql_disconnect(thread);
                EndThread((void*)thread);
                exit(0);
            } else if (strcmp(s, "rehash") == 0) {
				char *fgetstest = NULL;
				char si[10];
				bzero(&si,sizeof(si));
				
				FILE *pidcheck = fopen(m->pidfilename, "r" ); // open the pidfile in read mode to check if its represented
				int pid = (int)mygetpid(); // get the pid of the currently started process
				if(pidcheck != NULL){ // if no pidfile is represented try to write one
					fgetstest = fgets(si, 10, pidcheck);
					strclean(si);
					
					int ppid = stoi(si);
					if(pid != ppid){
						kill(ppid,SIGUSR2);
						printf(" [!] Rehashed orion-services (look to the logfiles, for further information)...\n");
						exit(0);
					}else exit(0);
				}
            } else if (strcmp(s, "shutdown") == 0) {
				char *fgetstest = NULL;
				char si[10];
				bzero(&si,sizeof(si));
				
				FILE *pidcheck = fopen(m->pidfilename, "r" ); // open the pidfile in read mode to check if its represented
				int pid = (int)mygetpid(); // get the pid of the currently started process
				if(pidcheck != NULL){ // if no pidfile is represented try to write one
					fgetstest = fgets(si, 10, pidcheck);
					strclean(si);
					
					int ppid = stoi(si);
					if(pid != ppid){
						kill(ppid,SIGTERM);
						remove_pidfile();
						printf(" [!] Shutdown orion-services...\n");
						exit(0);
					}else exit(0);
				}
            } else if (strcmp(s, "restart") == 0) {
				char si[10];
				char *fgetstest = NULL;
				bzero(&si,sizeof(si));
				
				FILE *pidcheck = fopen(m->pidfilename, "r" ); // open the pidfile in read mode to check if its represented
				int pid = (int)mygetpid(); // get the pid of the currently started process
				if(pidcheck != NULL){ // if no pidfile is represented try to write one
					fgetstest = fgets(si, 10, pidcheck);
					strclean(si);
					
					int ppid = stoi(si);
					if(pid != ppid){
						printf("\n [!] Restarting orion-services...\n\n");
						kill(ppid,SIGHUP);
					}else exit(0);
				}
            } else if (strcmp(s, "glinetime") == 0) {
                if (++i >= ac) {
                    fprintf(stderr, "-glinetime requires a parameter\n");
                    return -1;
                }
                s = av[i];
                if (stoi(s) <= 0) {
                    fprintf(stderr,
                            "-glinetime: number of seconds must be positive");
                    return -1;
                } else
                    m->socklinetime = stol(s);
            } else if (strcmp(s, "readtimeout") == 0) {
                if (++i >= ac) {
                    fprintf(stderr, "-readtimeout requires a parameter\n");
                    return -1;
                }
                s = av[i];
                if (stoi(s) <= 0) {
                    fprintf(stderr,
                            "-readtimeout: number of seconds must be positive");
                    return -1;
                } else
                    m->ReadTimeout = stoi(s);
            } else if (strcmp(s, "debug") == 0) {
                if (++i >= ac) {
                    fprintf(stderr, "-debug requires a parameter\n");
                    return -1;
                }
                if(stoi(av[i])<=5)
                	m->debug=stoi(av[i]);
                else{
                    fprintf(stderr, "-debug unknown debuglevel (only 0 to 5)\n");
                    return -1;
                }
                
/*                m->debug = 1;
            } else if (strcmp(s, "debug2") == 0) {
                m->debug = 2;
            } else if (strcmp(s, "debug3") == 0) {
                m->debug = 3;
            } else if (strcmp(s, "debug4") == 0) {
                m->debug = 4;
            } else if (strcmp(s, "debug5") == 0) {
                m->debug = 5;*/
            } else if (strcmp(s, "debuglogging") == 0) {
                m->debuglogging = 1;
            } else if (strcmp(s, "sqllogging") == 0) {
                if (++i >= ac) {
                    fprintf(stderr, "-sqllogging requires a parameter\n");
                    return -1;
                }
                dynncpy(m->sqllogfile,av[i],sizeof(m->sqllogfile));
                sqllogging = 1;
            } else if (strcmp(s, "readonly") == 0) {
                readonly = 1;
            } else if (strcmp(s, "nofork") == 0) {
                dofork = 0;
			}else if (strcmp(s, "logquotes") == 0) {
                if (++i >= ac) {
                    fprintf(stderr, "-logquotes requires a parameter\n");
                    return -1;
                }
                dynncpy(m->logquotes,av[i],sizeof(m->logquotes));
            } else if (strcmp(s, "logchan") == 0) {
                logchan = 1;
            } else if (!strcmp(s, "noexpire")) {
                noexpire = 1;
            } else if (!strcmp(s, "help")) {
                fprintf(stdout, "%s - [codename %s] %s\n",MAINPROJECT,PROJECTNAME,VERSION);
                fprintf(stdout,
                        "Orion IRC Services (http://www.orion-services.org)\n");
                fprintf(stdout, "Usage ./services [options] ...\n");
                fprintf(stdout, "-remote        -remote hostname[:port]\n");
                fprintf(stdout, "-name          -name servername\n");
                fprintf(stdout, "-user          -user serviceuser\n");
                fprintf(stdout, "-host          -host servicehost\n");
                fprintf(stdout, "-readtimeout   -readtimeout timeout(secs) | readtimeout from socket\n");

                fprintf(stdout, "-debug         -debug debugmode (0-5)\n");
                fprintf(stdout, "-debuglogging  -debuglogging\n");
                fprintf(stdout, "-debugbylog    -debugbylog logfile\n");
                fprintf(stdout, "-sqllogging    -sqllogging logfilename\n");
                fprintf(stdout, "-nofork        -nofork\n");
                fprintf(stdout, "-logchan       -logchan channelname\n");
                fprintf(stdout, "-readonly      -readonly\n");
                fprintf(stdout, "-noexpire      -noexpire\n");
                fprintf(stdout, "-version       -version\n");
                fprintf(stdout, "-help          -help\n");
                fprintf(stdout, "-log           -log logfilename\n");
                fprintf(stdout, "-glinetime     -glinetime seconds | sockscontrol glines\n");
                fprintf(stdout, "--------------------------------------------------\n");
                fprintf(stdout, "-rehash        -rehash        - rehashes the Modules & the Config\n");
                fprintf(stdout, "-restart       -restart       - restarts the Program\n");
                fprintf(stdout, "-shutdown      -shutdown      - Quits the Program\n");
                fprintf(stdout, "-giveroot      -giveroot nick - Gives SRA access (with owner levels) to pre-registered user)\n");
                fprintf(stdout, "-anopetodb     -anopetodb     - Moves Anopes databasefiles\n");
                fprintf(stdout, "   (db/nick.db db/chan.db db/hosts.db db/bot.db ..) to MySQL\n");
                fprintf(stdout, "-movedb        -movedb 0|1    - Moves DB data from AnopeDB to orion\n");
                fprintf(stdout, "   if you use BLOB in Anope DB (for passwords) give 1, otherwise 0\n");
                fprintf(stdout,
                        "Further support is available from http://www.orion-services.org\n");
                fprintf(stdout,
                        "Or visit US on IRC at irc.deepirc.net #orion\n");
                exit(EXIT_SUCCESS);
            } else {
                fprintf(stderr, "Unknown option -%s\n", s);
                return -1;
            }
        } else {
            fprintf(stderr, "Non-option arguments not allowed\n");
            return -1;
        }
    }
    return 0;
}

void sighandler(int signum)
{
    /* 
     * Sighandler
     */
	char *quitmsg;
	time_t startedtime = m->starttime;
	Threads *thread = SeekThread("IRC");

	dlog(thread,0,"SIGNUM = %d\n",signum);
	signal(SIGSEGV, SIG_DFL);
	if (m->starttime) {
#ifndef _WIN32
        if (signum == SIGHUP) { /* SIGHUP = save databases and restart */
            signal(SIGHUP, SIG_IGN);
            signal(SIGUSR2, SIG_IGN);
            int chdir_error = 0;
            remove_pidfile();
            
            alog(thread,"Received SIGHUP, restarting.\n");
  #ifdef USE_THREADS
			my_pthread_mutex_lock(&globvar_lock);
  #endif
            snprintf(squitmsg,sizeof(squitmsg),"(%s) Received SIGHUP ... restarting now",MAINPROJECT);
  #ifdef USE_THREADS
			my_pthread_mutex_unlock(&globvar_lock);
  #endif
  
            if(m->GlobalOnCycle)
				msend(thread,0,g->nick,_dynadd("$*%s",m->host),"%s",m->GlobalOnCycleMessage);
				
    		if (SERVICES_ROOT_DIR)
        		chdir_error = chdir(SERVICES_ROOT_DIR);

			exitservices(thread);
			closelink(thread);
			
			close_all_logs("(%s) Received SIGHUP ... restarting now",MAINPROJECT);

#ifdef _WIN32
        	/* This fixes bug #589 - change to binary directory for restart */
        	/*  -- heinz */
        	//if (SERVICES_BIN)
            //	chdir(SERVICES_BIN);
#endif
    		execve(SERVICES_BIN, my_av, my_envp);
#ifdef _WIN32
			exit(EXIT_SUCCESS);
#else
			exit(0);
#endif

#endif
#ifdef _WIN32
		if (signum == SIGQUIT) {
#else
        } else if (signum == SIGQUIT) {
#endif
            /* had to move it to here to make win32 happy */
        } else if (signum == SIGUSR2) {
			int i       = 0;
			int modules = 0;
			MOD_BOOL mod_status = MOD_CONT;
			
            alog(thread,"Received SIGUSR2: Rehash Configuration\n");

#ifdef USE_THREADS
			my_pthread_mutex_lock(&globvar_lock);
#endif
			zero_config_values(thread);
            loadconf(thread,"services");
			if(proof_config(thread)==0){
				do_global(thread,m->servername,"  * ERROR: Reloading Config failed ...");
				dlog(thread,0,"  * ERROR: Reloading Config failed ...");
				mod_status = MOD_STOP;
			}else{
				rehashModuleConfigs(thread);
				do_global(thread,m->servername," [*] Reloaded Config ...");
			}

			m->starttime = startedtime;
#ifdef USE_THREADS
			my_pthread_mutex_unlock(&globvar_lock);
#endif

			dynclose(thread,IRC.dl_handle);
			bzero(&IRC,sizeof(IRC));
			
			if(LoadProtocol(thread,&IRC,m->protocol)){
				do_global(thread,m->servername," [*] Reloaded IRC-Protocol Module ...");
				//printf(" [*] Reloaded IRC-Protocol Module ...\n");
			}else{
				do_global(thread,m->servername,"  * ERROR: Reloading IRC-Protocol Module failed ...");
				dlog(thread,0,"  * ERROR: Reloading Config failed ...");
				mod_status = MOD_STOP;
			}
			
			if(m->UseWebForm){
				dynclose(thread,WebForm.dl_handle);
				bzero(&WebForm,sizeof(WebForm));
				if(LoadProtocol(thread,&WebForm,"WebForm")){
					do_global(thread,m->servername," [*] Reloaded WebFrom-Protocol Module ...");
				}else{
					do_global(thread,m->servername,"  * ERROR: Reloading WebForm-Protocol Module failed ...");
					dlog(thread,0,"  * ERROR: Reloading Config failed ...");
					mod_status = MOD_STOP;
				}
			}
			
			
			/* Re Initializes the Languages */
			reinit_langs(thread);
			
			do_global(thread,m->servername," [*] Reloaded Language Files ...");
			modules=getmodules(thread); // Loades Modules
			while(i<modules){
				if(modul[i][0]!='\0'){
					reload_modules(thread,modul[i]); //Loads the Modules
					do_global(thread,m->servername," [*] Reloaded \"%s\" ...",modul[i]);
				}
				i++;
			}
			reload_modules(thread,"orion");
			
			do_global(thread,m->servername," [*] Reloaded all Modules ...");
			if(mod_status){
				do_global(thread,m->servername," [*] Rehashed without any problems ...");
				//printf(" [*] Rehashed orion-services successful...");
			}else{
				do_global(thread,m->servername," * ERROR: Rehash incomplete, errors encountered (check your debug log!)...");
				//printf(" [*] Rehashed orion-services successful...");
			}
			
			//return;
        } else if (signum == SIGTERM) {
            signal(SIGTERM, SIG_IGN);
#ifndef _WIN32
            signal(SIGHUP, SIG_IGN);
#endif
            alog(thread,"Received SIGTERM, exiting.\n");
            
#ifdef USE_THREADS
			my_pthread_mutex_lock(&globvar_lock);
#endif
            snprintf(squitmsg,sizeof(squitmsg),"(%s) Received shutdown from terminal (SIGTERM) ... shutting down",MAINPROJECT);
#ifdef USE_THREADS
			my_pthread_mutex_unlock(&globvar_lock);
#endif

            orion_exit(thread);
        } else if (signum == SIGINT) {
            if (!dofork) {
                signal(SIGINT, SIG_IGN);
                alog(thread,"Received SIGINT, exiting.\n");
                //do_server_notice("(%s) Shutdown received from terminal, shutting down",MAINPROJECT);
#ifdef USE_THREADS
				my_pthread_mutex_lock(&globvar_lock);
#endif
                snprintf(squitmsg,sizeof(squitmsg),"(%s) Received shutdown from terminal (SIGINT)",MAINPROJECT);
#ifdef USE_THREADS
				my_pthread_mutex_unlock(&globvar_lock);
#endif

                orion_exit(thread);
            }
        }
    }

    if (
#if (!defined(USE_THREADS) || !defined(LINUX20)) && !defined(_WIN32)
           signum == SIGUSR1 ||
#endif
           !(quitmsg = (char*)calloc(BUFSIZE, 1))) {
        quitmsg = "Out of memory!";
    } else {
        dlog(thread,0,"Services terminating on signal %d - quit: %s\n",
                 signum,quitmsg);
    }

    if (signum == SIGSEGV) {
#ifdef HAVE_BACKTRACE
    	do_backtrace(thread,1,17);
#endif

/*#ifdef USE_THREADS
		my_pthread_mutex_lock(&globvar_lock);
#endif*/
		snprintf(squitmsg,sizeof(squitmsg),"(%s) Segfault, shutting down - read logfile",MAINPROJECT);
		do_squit(thread,m->servername,squitmsg);
/*#ifdef USE_THREADS
		my_pthread_mutex_unlock(&globvar_lock);
#endif*/

		_orion_exit();
	}
}

#if defined(USE_THREADS) && defined(THREAD_PROCESSES)
/*  ************************************************************************************************
 *
 *  Copyright (C) 2004-2009
 *      Manuel Moser (alias: shock), Email: shock@deepirc.net
 *
 *  ************************************************************************************************
 *
 *  This are the separated Threads which may only be executed
 *  when the Operating System allows you to, cauze you need some librarys
 *	such as "pthread" to make threads working.
 *
 *  Functions which are used in threads HAVE TO BE REENTRANT!! (never forget about that)
 *  Orion was designed to execute up to 1024 processes (threads/tasks) so all functions were designed
 *  reentrant!!
 *
 *  ************************************************************************************************  */

/**
 * @brief Nicksvalidation thread
 *
 * The Nickvalidation Thread checks if the users of all registered<br/>
 *   nicks identified for them on time!
 *
 * @param in_thread The thread-struct (pointer to the threads data)- holds the threads information
 * @return void*
 */
void *TValidatenicks (void *in_thread) {
	Threads *thread = (Threads *)in_thread;

	/* Variables */
	time_t LastNickCheckDelay = 10;

	/* Set thread attributes */
	pthread_setcancelstate (PTHREAD_CANCEL_ENABLE, NULL);
	pthread_cleanup_push   (EndThread,(void *)thread);

	/* Connect the Thread to SQL */
	my_pthread_mutex_lock(&mysql_lock);
	mysql_thread_init(); /* Initialize MySQL for Threading */
	my_pthread_mutex_unlock(&mysql_lock);

	while(1){
		sleep(20);
		//while(time(NULL)<LastNickCheckDelay)
		//	sched_yield();
		
		if(!DuringServerlink){
			time_t WarnTime = time(NULL)-LastNickCheckDelay;
			Users *user = NULL;

			for(user = users; user; user = user->next){
                if(user->ns_warntime<=WarnTime && user->ns_warntime>0){
					if(getUline(thread,user->server)!=NULL)
						continue;

					if(user->faketype == FAKETYPE_RELEASEUSER)
						do_kill(thread,ns->nick,user->nick,"Nickname released from a requested recover");

					else if((user->settings&NS_SET_KILLPROTECT && user->ns_warntime<=(time(NULL)-60)) ||
						   (m->NSQuickKill>0 && user->settings&NS_SET_KILL_QUICK && user->ns_warntime<=(time(NULL)-m->NSQuickKill)) ||
						   (m->NSImmedKill>0 && user->settings&NS_SET_KILL_IMMED && user->ns_warntime<=(time(NULL)-m->NSImmedKill))){
						if(IRC.SvsNick){
							char number[GUEST_NUMBER_LEN+1];
							char newnick[MAX_NICK_LEN*2];

							bzero(&number,sizeof(number));
							bzero(&newnick,sizeof(newnick));
							randomnumber(number,GUEST_NUMBER_LEN);

							dynncpy(newnick,m->NSGuestNickPrefix,sizeof(newnick));
							straddns(newnick,number,sizeof(newnick));
							strclean(newnick);

							/* Change his nick to GuestXXX.. */
							while(GetUser(newnick)!=NULL){
								bzero(&number,sizeof(number));
								bzero(&newnick,sizeof(newnick));
								randomnumber(number,GUEST_NUMBER_LEN);

								dynncpy(newnick,m->NSGuestNickPrefix,sizeof(newnick));
								straddns(newnick,number,sizeof(newnick));
								strclean(newnick);
							}

							do_svsnick(thread,ns->nick,user->nick,newnick);
						}else{
							do_kill(thread,ns->nick,user->nick,"Not Identified");
						}
					}
				}
			}
			/* free Quotes-Array */
			mysql_free_quotes(thread);
		}
		//LastNickCheckDelay = time(NULL)+10;
	}
	
	/* End Thread */
	mysql_thread_end();
	pthread_cleanup_pop(0);
	pthread_exit(NULL);
	return NULL;
}

/*  ************************************************************************************************  */

/**
 * @brief Miscellous Thread
 *
 * The Miscellous Thread controls miscellous's actions<br/>
 *   and checks network status periodically
 *
 * @param in_thread The thread-struct (pointer to the threads data)- holds the threads information
 * @return void*
 */
void *TCheckMiscStuff (void *in_thread) {
	Threads *thread = (Threads *)in_thread;

	/* Variables */
	sqldumptime 		= time(NULL);
	StayRefreshTime		= time(NULL);
	LimitRefreshTime	= time(NULL);
    LastUsedCheck		= time(NULL);
    time_t Delay        = minValue(4,m->TrustDumpTime,m->CSStayChannel,m->LimitCheck,m->NickUsedCheck);

	/* Set thread attributes */
	pthread_setcancelstate (PTHREAD_CANCEL_ENABLE, NULL);
	pthread_cleanup_push   (EndThread,(void *)thread);

	/* Connect the Thread to SQL */
	my_pthread_mutex_lock(&mysql_lock);
	mysql_thread_init(); /* Initialize MySQL for Threading */
	my_pthread_mutex_unlock(&mysql_lock);

	while(1){
		sleep(60);
		//while(time(NULL)<Delay)
		//	sched_yield();

    	/* Dumping from the Database to memory in a period of 30 minutes! */
/* P3 */if(sqldumptime+m->TrustDumpTime<=time(NULL) && !DuringServerlink){
		 	//In that case it's time for flushing the memory, with new DB-data
			//Delete out of memory
			dlog(thread,0,"--- flushing sql trusts ---\n");
			DelTrustgroups(); 	/* Clear Trustgroups - In the memory */
			DelTrusts(); 		/* Clear Trusts - In the memory */

			domysql(thread,"FLUSH QUERY CACHE");
			//domysql(thread,"RESET QUERY CACHE");

			//Insert in the memory again - Dumping
			GetTrustsSql(thread);
			GetTrustgroupsSql(thread);

			//Done we have to increase the "sqldumptime"
			sqldumptime=time(NULL);
		} /* Flushing memory with new data done, executing other Processes */

/* P4 */if(StayRefreshTime+m->CSStayChannel<=time(NULL) && !DuringServerlink){
			PerformStay(thread);
			StayRefreshTime=time(NULL);
		}

/* P5 */if(LimitRefreshTime+m->LimitCheck<=time(NULL) && !DuringServerlink){ /* Change Limits for Q-Channels where a join,part,quit or something occured */
			PerformLimits(thread);
			delLimits(thread);
			LimitRefreshTime=time(NULL);
		}

/* P6 */if(LastUsedCheck+m->NickUsedCheck<=time(NULL) && !DuringServerlink){ /* Change Last Used state (before Expiring Groups) - to avoid Bouncer Expiring */
			domysql(thread,"UPDATE `orion_ns_aliases` LEFT OUTER JOIN `orion_cs_access` ON `orion_cs_access`.`authnick`=`orion_ns_aliases`.`display` LEFT OUTER JOIN `orion_cs_core` ON `orion_cs_core`.`channel`=`orion_cs_access`.`channel` SET `orion_ns_aliases`.`last_used`='%ld', `orion_cs_core`.`last_used`='%ld' WHERE `orion_ns_aliases`.`active`='1'",time(NULL),time(NULL));
			LastUsedCheck=time(NULL);
		}
		
		/* free Quotes-Array */
		mysql_free_quotes(thread);
		
		//Delay = time(NULL)+minValue(4,m->TrustDumpTime,m->CSStayChannel,m->LimitCheck,m->NickUsedCheck);
	}

	/* End Thread */
	mysql_thread_end();
	pthread_cleanup_pop(0);
	pthread_exit(NULL);
	return NULL;
}

/*  ************************************************************************************************  */

/**
 * @brief Sockscontrol Thread
 *
 * The Sockscontrol Thread controls sockscontrol's actions<br/>
 *   and checks network status periodically
 *
 * @param in_thread The thread-struct (pointer to the threads data)- holds the threads information
 * @return void*
 */
void *TSockscontrol (void *in_thread) {
	Threads *thread = (Threads *)in_thread;

	/* Variables */
	PingCheckTime       = time(NULL);
	time_t PingDelay	= 90;
	time_t Delay 		= minValue(2,90,SC->sockseconds);

	/* Set thread attributes */
	pthread_setcancelstate (PTHREAD_CANCEL_ENABLE, NULL);
	pthread_cleanup_push   (EndThread,(void *)thread);

	/* Connect the Thread to SQL */
	my_pthread_mutex_lock(&mysql_lock);
	mysql_thread_init(); /* Initialize MySQL for Threading */
	my_pthread_mutex_unlock(&mysql_lock);

	while(1){
		//while(time(NULL)<Delay)
		//	sched_yield();
		sleep(5);
		
/* P1 */if(PingCheckTime+PingDelay<=time(NULL) && DuringServerlink){
			if(linkserver[0]!='\0')
				orion_WRCtranslate_cmd_pong(thread,m->servername,linkserver);

			PingCheckTime = time(NULL);
		}

		/* Sockscontrol Process - Poll time */
/* P2 */_ExecuteEvent(NULL,NULL,"socks_check");

		/* free Quotes-Array */
		mysql_free_quotes(thread);
	}

	/* End Thread */
	mysql_thread_end();
	pthread_cleanup_pop(0);
	pthread_exit(NULL);
	return NULL;
}

/*  ************************************************************************************************  */

/**
 * @brief Expiration Thread
 *
 * The Expiration Thread ensures that all unused<br/>
 *   nicks expire on time.
 *
 * @param in_thread The thread-struct (pointer to the threads data)- holds the threads information
 * @return void*
 */
void *TExpiration (void *in_thread) {
	Threads *thread = (Threads *)in_thread;

	/* Variables */
	time_t Delay 		= m->ExpireCheckTime;

	/* Set thread attributes */
	pthread_setcancelstate (PTHREAD_CANCEL_ENABLE, NULL);
	pthread_cleanup_push   (EndThread,(void *)thread);

	/* Connect the Thread to SQL */
	my_pthread_mutex_lock(&mysql_lock);
	mysql_thread_init(); /* Initialize MySQL for Threading */
	my_pthread_mutex_unlock(&mysql_lock);

	while(1){
		//while(time(NULL)<Delay)
		//	sched_yield();
		sleep(Delay);
		do_logchan(thread,NULL,NULL,NULL,NULL,"Delay = %d",Delay);

/* P7 */if(!DuringServerlink){
#if MAX_CHANNELNAME_LEN > MAX_NICK_LEN
			char anickchan[MAX_CHANNELNAME_LEN*2];
			char nick     [MAX_NICK_LEN*2];
#else
			char anickchan[MAX_NICK_LEN*2];
			char nick     [MAX_NICK_LEN*2];
#endif

			char chan_delete[MAX_CHANNELNAME_LEN*70];
			char chan_update[MAX_CHANNELNAME_LEN*70];
			char channel_all[MAX_CHANNELNAME_LEN*70*2];
			char groupnicks[MAX_NICK_LEN*70];
			char *nickgroup[300];

			time_t gettime    		= 0;
			time_t usrexpire  		= 0;
			time_t reqexpire  		= 0;
			time_t chanexpire 		= 0;
			int j					= 0;
			int i					= 0;
			size_t a				= 0;
			int lastgroupmember		= 0;
			bool expiremain  		= 0;

			deepSQL getSQL[2];
			bzero(&getSQL    ,sizeof(getSQL));
			bzero(&anickchan ,sizeof(anickchan));
			bzero(&nick      ,sizeof(nick));

			bzero(&chan_delete      ,sizeof(chan_delete));
			bzero(&chan_update      ,sizeof(chan_update));
			bzero(&channel_all      ,sizeof(channel_all));
			bzero(&groupnicks       ,sizeof(groupnicks));
			bzero(nickgroup         ,sizeof(nickgroup));

			gettime    = time(NULL);
			reqexpire  = gettime - m->NSRExpire;
			usrexpire  = gettime - expire(m->NSExpire);
			chanexpire = gettime - expire(m->CSExpire);

			getSQL[0].res    = doSelectMySQL(thread,
				"SELECT DISTINCT "
					"`orion_ns_aliases`.`display`,"
					"`orion_ns_aliases`.`nick`,"
					"`orion_ns_aliases`.`last_used`,"

					"SUM("
						"IF(`orion_ns_aliases`.`expire`='1' AND `orion_ns_aliases`.`last_used` <= '%ld',1,0)" // usrexpire
					") AS `count_expire`,"

					"COUNT(DISTINCT `orion_ns_aliases`.`nick`) AS `groupmembers`,"

					"GROUP_CONCAT(DISTINCT "
										"`orion_ns_aliases`.`nick` ORDER BY `orion_ns_aliases`.`expire` DESC,"
										"`orion_ns_aliases`.`last_used` ASC"
					") AS `nicks_sorted`,"

					"`orion_ns_core`.`email`,"
					"`orion_ns_core`.`settings`,"

					"("

						"SELECT "
							"GROUP_CONCAT(`channel`) FROM `orion_cs_core` AS `core2` "

						"WHERE "
							"`core2`.`successor`=`orion_ns_aliases`.`display` OR "
							"`core2`.`founder`=`orion_ns_aliases`.`display`"

					") AS `role_in_channel` "

					"FROM `orion_ns_aliases` "
						"LEFT OUTER JOIN `orion_ns_core` ON `orion_ns_aliases`.`display` = `orion_ns_core`.`authnick` "

				"WHERE "
					"`orion_ns_aliases`.`forbid`='0' AND "
					"`orion_ns_aliases`.`linked`='0' "

				"GROUP BY "
					"`orion_ns_aliases`.`display` "

				"HAVING "
					"SUM("
						"IF(`orion_ns_aliases`.`expire`='1' AND `orion_ns_aliases`.`last_used` <= '%ld',1,0)" // usrexpire
					")>0 "
				"ORDER BY `orion_ns_aliases`.`display` ASC",
				usrexpire,usrexpire
			);

			getSQL[0].fields = mysql_num_rows(getSQL[0].res);
			if(getSQL[0].fields){

				for(i=0;i<getSQL[0].fields;i++){
					getSQL[0].row = mysql_fetch_row(getSQL[0].res);

					if(stoi(getSQL[0].row[7])&NS_SUSPENDED)
						continue;

					bzero(&anickchan,sizeof(anickchan));
					bzero(&nick,sizeof(nick));

					mysql_real_escape_string(MYSQL_CONNECTION_HANDLE, anickchan, getSQL[0].row[0], strlen(getSQL[0].row[0]));
					mysql_real_escape_string(MYSQL_CONNECTION_HANDLE, nick, getSQL[0].row[1], strlen(getSQL[0].row[1]));

					if(stoi(getSQL[0].row[4])-stoi(getSQL[0].row[3])==0){
						/* Expire a complete NickGroup, since the Group has only a single Nick in it and that one expires - that's a pitty =/ */
						do_logchan(thread,NULL,NULL,NULL,NULL,"Expiring Nickgroup of %s (group: %s) (e-mail: %s) [Last Used on: %s]",getSQL[0].row[1],getSQL[0].row[0],getSQL[0].row[6],get_localtime(atol(getSQL[0].row[2])));

						domysql(thread,"DELETE `orion_ns_core`,`orion_ms_core` FROM `orion_ns_core` LEFT OUTER JOIN `orion_ms_core` ON (`orion_ms_core`.`receiver`=`orion_ns_core`.`authnick`) WHERE `orion_ns_core`.`authnick`='%s'",anickchan);
						if(getSQL[0].row[8]!=NULL)
							domysql(thread,"UPDATE `orion_cs_core` SET `founder`=IF(`founder`='%s',IF(`successor`='%s',NULL,`successor`),`founder`),`last_used`=IF(IF(`founder`='%s',IF(`successor`='%s',NULL,`successor`),`founder`) IS NOT NULL, `last_used`, '0'),`successor`=NULL WHERE `channel` IN ('%s')",anickchan,anickchan,anickchan,anickchan,getSQL[0].row[8]);

					}else if(stoi(getSQL[0].row[4])-stoi(getSQL[0].row[3])>0){
						lastgroupmember = stoi(getSQL[0].row[4])-1;
						/* Expire the Nicknames */
						//do_logchan(thread,NULL,NULL,NULL,NULL,"Expiring nickname %s (group: %s) (e-mail: %s) [Last Used on: %s]",getSQL[0].row[1],getSQL[0].row[0],getSQL[0].row[6],get_localtime(atol(getSQL[0].row[2])));
						dynncpy(groupnicks,getSQL[0].row[5],sizeof(groupnicks));
						a = strsplit(groupnicks,nickgroup,',');
						for(j=0;j<stoi(getSQL[0].row[3]);j++){
							if(!streqnc(nickgroup[j],getSQL[0].row[0])){
								domysql(thread,"DELETE FROM `orion_ns_aliases` WHERE `nick`='%s'",mysql_quote(thread,nickgroup[j]));
								do_logchan(thread,NULL,NULL,NULL,NULL,"Expiring nickname %s (group: %s) (e-mail: %s) [Last Used on: %s]",nickgroup[j],getSQL[0].row[0],getSQL[0].row[6],get_localtime(atol(getSQL[0].row[2])));
							}
							else{
								expiremain=1;
							}
						}

						if(expiremain){
							//domysql(thread,"DELETE `orion_ns_aliases`,`orion_hs_core` FROM `orion_ns_aliases` LEFT OUTER JOIN `orion_hs_core` ON (`orion_hs_core`.`nick`=`orion_ns_aliases`.`nick`) WHERE `orion_ns_aliases`.`nick`='%s'",nick);

							/* orion_hs_core done with cascade update / delete */
							domysql(thread,"DELETE FROM `orion_ns_aliases` WHERE `nick`='%s'",anickchan);
							domysql(thread,"UPDATE `orion_ns_core` LEFT OUTER JOIN `orion_ms_core` ON (`orion_ms_core`.`receiver`=`orion_ns_core`.`authnick`) SET `orion_ns_core`.`authnick`='%s',`orion_ms_core`.`receiver`='%s' WHERE `orion_ns_core`.`authnick`='%s'",mysql_quote(thread,nickgroup[lastgroupmember]),mysql_quote(thread,nickgroup[lastgroupmember]),anickchan);

							/* Changing Display - Since old Display expired! */
							do_logchan(thread,NULL,NULL,NULL,NULL,"Changed Display from %s (group: %s) to %s -> (NewGroupID: %s) (e-mail: %s)",getSQL[0].row[0],getSQL[0].row[0],nickgroup[lastgroupmember],nickgroup[lastgroupmember],getSQL[0].row[6]);
						}

						expiremain=0;
					}
				}
			}
			/* free result */
			mysql_free_result_myr(getSQL[0].res);

			getSQL[1].res    = doSelectMySQL(thread,"SELECT `orion_cs_core`.`channel`,(COUNT(`orion_chan_users`.`nick`)-SUM(IF(`orion_chan_users`.`nick`=`orion_cs_core`.`botnick`,1,0))) as `users`, `orion_cs_core`.`botnick` ,SUM(IF(`orion_chan_users`.`nick`=`orion_cs_core`.`botnick`,1,0)) as `botinchan`, `orion_cs_core`.`serv`, `orion_cs_core`.`datecreate`, `orion_cs_core`.`founder`, `orion_cs_core`.`settings` FROM `orion_cs_core` LEFT JOIN `orion_chan_users` ON `orion_chan_users`.`channel` = `orion_cs_core`.`channel` WHERE `orion_cs_core`.`serv`<>'' AND `last_used` <= '%d' AND `orion_cs_core`.`expire`='1' GROUP BY `orion_cs_core`.`channel`",chanexpire);
			getSQL[1].fields = mysql_num_rows(getSQL[1].res);
			if(getSQL[1].fields){
				for(i=0;i<getSQL[1].fields;i++){
                    
					getSQL[1].row = mysql_fetch_row(getSQL[1].res);
					
                    do_logchan(thread,NULL,NULL,NULL,NULL,"row[0] = %s | row[1] = %s | row[4] = %s | row[5] = %s => chanexpire=%d",getSQL[1].row[0],getSQL[1].row[1],getSQL[1].row[4],getSQL[1].row[5],chanexpire);

					if(stoi(getSQL[1].row[7])&CS_SUSPEND_BIT)
						continue;
					if(stoi(getSQL[1].row[7])&CS_FORBID_BIT)
						continue;

					int count_users_offset = 0;
					/* We proof if channel had inhabitant set and ChanServ is really in (if he is in we higher the user_count offset) */
					if(stoi(getSQL[1].row[7])&CS_INHABIT_BIT){
						Users 		*my_chanserv 		= GetUser(cs->nick);
						Uchannels 	*my_chanserv_channel= NULL;

						if(my_chanserv!=NULL)
							my_chanserv_channel = GetUserChannel(my_chanserv,thread->c.chan.name);

						/* WOOHOOO ChanServ isn't in the Channel yet */
						if(my_chanserv_channel!=NULL && my_chanserv_channel->isin_chan){
                            count_users_offset++;
						}
					}

					/* We proof if channel is a Q channel and Q is really in (if he is in we higher the user_count offset) */
					else if(streqnc(getSQL[1].row[4],"q")){
						Users 		*my_chanserv 		= GetUser(Q->nick);
						Uchannels 	*my_chanserv_channel= NULL;

						if(my_chanserv!=NULL)
							my_chanserv_channel = GetUserChannel(my_chanserv,thread->c.chan.name);

						/* WOOHOOO ChanServ isn't in the Channel yet */
						if(my_chanserv_channel!=NULL && my_chanserv_channel->isin_chan){
                            count_users_offset++;
						}
					}

					/* wenn getSQL[1].row[1] = 0  -> liste zusammenstellen mit allen zu lschenden channels -> ('#channel1','#channel2') */
					/* wenn getSQL[1].row[1] > 0  -> liste zusammenstellen mit allen zu nicht zu lschenden channels (nur update) -> ('#channel1','#channel2') */
					if(stoi(getSQL[1].row[1])==count_users_offset){
						straddnc(chan_delete,(char)39,sizeof(chan_delete));
						straddns(chan_delete,mysql_quote(thread,getSQL[1].row[0]),sizeof(chan_delete));
						straddnc(chan_delete,(char)39,sizeof(chan_delete));
						straddnc(chan_delete,',',sizeof(chan_delete));
					}else if(stoi(getSQL[1].row[1])>count_users_offset){
						straddnc(chan_update,(char)39,sizeof(chan_update));
						straddns(chan_update,mysql_quote(thread,getSQL[1].row[0]),sizeof(chan_update));
						straddnc(chan_update,(char)39,sizeof(chan_update));
						straddnc(chan_update,',',sizeof(chan_update));
					}

					if(stoi(getSQL[1].row[7])&CS_INHABIT_BIT)
					    orion_WRCtranslate_cmd_part(thread,cs->nick,getSQL[1].row[0],"channel expired");
                    else if(streqnc(getSQL[1].row[4],"q"))
					    orion_WRCtranslate_cmd_part(thread,Q->nick,getSQL[1].row[0],"channel expired");

					if(getSQL[1].row[2]!=NULL && stoi(getSQL[1].row[3])==1){
						do_rawmode(thread,getSQL[1].row[2],getSQL[1].row[0],stol(getSQL[1].row[5]) == 0 ? time(NULL) : stol(getSQL[1].row[5]),IRC.ModeOnChannelDrop);
						orion_WRCtranslate_cmd_part(thread,getSQL[1].row[2],getSQL[1].row[0],"channel expired");
					}
					else if(getSQL[1].row[2]==NULL || stoi(getSQL[1].row[3])==1){
						if(streqnc(getSQL[1].row[4],"chanserv")) do_rawmode(thread,cs->nick,getSQL[1].row[0],stol(getSQL[1].row[5]) == 0 ? time(NULL) : stol(getSQL[1].row[5]),IRC.ModeOnChannelDrop);
						else if(streqnc(getSQL[1].row[4],"q"))	do_rawmode(thread,Q->nick,getSQL[1].row[0],stol(getSQL[1].row[5]) == 0 ? time(NULL) : stol(getSQL[1].row[5]),IRC.ModeOnChannelDrop);
					}
					/* Channel Expires */
					if(getSQL[1].row[6]!=NULL)
						do_logchan(thread,NULL,NULL,NULL,NULL,"Expiring channel %s (founder: %s)",getSQL[1].row[0],getSQL[1].row[6]);

				}

				a=dynlen(chan_update);

				if(a>0) chan_update[a-1]='\0';
					a=dynlen(chan_delete);
				if(a>0) chan_delete[a-1]='\0';

				dlog(thread,3,"chan_delete = %s\n",chan_delete);
				dlog(thread,3,"chan_update = %s\n",chan_update);

				if(chan_delete[0]!='\0')
					straddns(channel_all,chan_delete,sizeof(channel_all));

				if(chan_update[0]!='\0'){
					if(channel_all[0]!='\0'){
						straddnc(channel_all,',',sizeof(channel_all));
						straddns(channel_all,chan_update,sizeof(channel_all));
					}else
						straddns(channel_all,chan_update,sizeof(channel_all));
				}

				if(channel_all[0]!='\0'){
                    domysql(thread,"DELETE FROM `orion_chan_users` WHERE `orion_chan_users`.`nick`='%s' AND `orion_chan_users`.`channel` IN(%s)",cs->nick,channel_all);
					domysql(thread,"DELETE `orion_chan_users` FROM `orion_chan_users` LEFT OUTER JOIN `orion_cs_core` ON (`orion_cs_core`.`botnick`=`orion_chan_users`.`nick` AND `orion_cs_core`.`channel`=`orion_chan_users`.`channel`) WHERE `orion_cs_core`.`botnick` IS NOT NULL AND `orion_chan_users`.`channel` IN(%s)",channel_all);
					domysql(thread,"DELETE `orion_cs_akick`,`orion_ms_core` FROM `orion_cs_akick` LEFT OUTER JOIN `orion_ms_core` ON (`orion_cs_akick`.`channel`=`orion_ms_core`.`receiver`) WHERE `orion_cs_akick`.`channel` IN (%s)",channel_all);
				}

				if(chan_delete[0]!='\0')
					domysql(thread,"DELETE FROM `orion_cs_core` WHERE `channel` IN (%s)",chan_delete);

				if(chan_update[0]!='\0')
					domysql(thread,"UPDATE `orion_cs_core` SET "
							"`botnick`=NULL,`serv`='',`founder`=NULL,`successor`=NULL,`email`='',`settings`='',`regdate`='',`description`='',`mlock_positive`='',"
							"`mode`=REPLACE(`mode`,'r',''),`mlock_negative`='',`mlock_limit`='',`mlock_key`='',`mlock_flood`='',`url`='',`alimit`='',`flags`='',"
							"`welcome`='',`reason`='',`last_used`='',`mlock_redirect`='',`expire`='',`maxmemos`='',"
							"`cs_set`='',`cs_autodeop`='',`cs_autohalfop`='',`cs_autoop`='',`cs_autoprotect`='',`cs_autovoice`='',"
							"`cs_nojoin`='',`cs_signkick`='',`cs_acclist`='',`cs_accchange`='',`cs_akick`='',`cs_ban`='',`cs_banme`='',"
							"`cs_cclear`='',`cs_getkey`='',`cs_halfop`='',`cs_halfopme`='',`cs_info`='',`cs_kick`='',`cs_kickme`='',`cs_invite`='',"
							"`cs_opdeop`='',`cs_opdeopme`='',`cs_protect`='',`cs_protectme`='',`cs_topic`='',`cs_unban`='',`cs_voice`='',"
							"`cs_voiceme`='',`cs_memo`='',`cs_botassign`='',`cs_badwords`='',`cs_fantasia`='',`cs_greet`='',`cs_nokick`='',"
							"`cs_say`='',`bs_set`='-1',`bs_caps_ttb`='-1',`bs_caps_min`='-1',`bs_caps_per`='-1',`bs_flood_ttb`='-1',`bs_flood_ln`='-1',`bs_flood_secs`='-1',`bs_repeat_ttb`='-1',`bs_repeat`='-1',"
							"`bs_colors`='-1',`bs_underlines`='-1',`bs_reverses`='-1',`bs_badwords`='-1',`bs_bolds`='-1'"

						" WHERE `channel` IN (%s)",chan_update);

			}
			/* free result */
			mysql_free_result_myr(getSQL[1].res);

			/* free Quotes-Array */
			mysql_free_quotes(thread);

			if(m->UseWhowas)
				domysql(thread,"DELETE FROM `orion_core_condata_log` WHERE `localtime` <= '%d'",time(NULL)-m->KeepWhowasLog);

			/* domysql(thread,"DELETE FROM `orion_core_glines` WHERE `duration` <= '%d' AND `duration`!='0'",gettime); */
			domysql(thread,"DELETE `orion_os_szlines`,`orion_os_sqlines`,`orion_core_glines` FROM `orion_os_szlines` LEFT OUTER JOIN `orion_os_sqlines` ON (`orion_os_sqlines`.`duration`=`orion_os_szlines`.`duration`) LEFT OUTER JOIN `orion_core_glines` ON (`orion_core_glines`.`duration`=`orion_os_szlines`.`duration`) WHERE `orion_os_szlines`.`duration` <= '%ld' AND `orion_os_szlines`.`duration`!='0'",gettime);
			domysql(thread,"DELETE FROM `orion_core_lines` WHERE `duration` <= '%ld' AND `duration`!='0' AND `duration`!=''",gettime);

			if(m->NSEmailReg)
				domysql(thread,"DELETE FROM `orion_ns_request` WHERE `reqtime` <= '%ld' AND `reqtime`!='0' AND `reqtime`!=''",reqexpire);

		}
		
		//Delay = time(NULL)+m->ExpireCheckTime;
	}

	/* End Thread */
	mysql_thread_end();
	pthread_cleanup_pop(0);
	pthread_exit(NULL);
	return NULL;
}

/*  ************************************************************************************************  */

#endif

/*  ************************************************************************************************
 *
 *  Copyright (C) 2004-2009
 *      Manuel Moser (alias: shock), Email: shock@deepirc.net
 *
 *  ************************************************************************************************
 *
 *  This it the main loop..
 *  It keeps the program alive and is separated into parts like "processes"
 *  These processes are executed periodically with timedelays.
 *
 *  There are possibly some processes which are executed as separated detached threads
 *  to enhance performance and structing.
 *
 *  ************************************************************************************************  */
int main(int ac, char *av[], char **envp){
	int i          	= 0;
	int modules    	= 0;
	int bytes_read 	= 0;
    int started_from_term = isatty(0) && isatty(1) && isatty(2);
    MOD_ERROR ModErr;
    
    my_av = av;
    my_envp = envp;
    
	/***** LEVEL changing Q<->ChanServ *****/
	FillLevel( &leveltable[0], "AUTOOP",1,"cs_autoop",CS_AUTOOP, "a*o" );
	FillLevel( &leveltable[1], "AUTOHALFOP",1,"cs_autohalfop",CS_AUTOHALFOP, "a*h" );
	FillLevel( &leveltable[2], "AUTOVOICE",1,"cs_autovoice",CS_AUTOVOICE, "a*v" );
	FillLevel( &leveltable[3], "AUTOPROTECT",1,"cs_autoprotect",CS_AUTOPROTECT, "a*p" );
	FillLevel( &leveltable[4], "AUTODEOP",1,"cs_autodeop",CS_AUTODEOP, "" );
	FillLevel( &leveltable[5], "NOJOIN",1,"cs_nojoin",CS_NOJOIN, "b" );
	FillLevel( &leveltable[6], "SIGNKICK",1,"cs_signkick",CS_SIGNKICK, "h" );
	FillLevel( &leveltable[7], "ACC-LIST",1,"cs_acclist",CS_ACCESS_LIST, ".+" );
	FillLevel( &leveltable[8], "ACC-CHANGE",1,"cs_accchange",CS_ACCESS_CHANGE, "m" );
	FillLevel( &leveltable[9], "AKICK",1,"cs_akick",CS_AKICK, "o" );
	FillLevel( &leveltable[10], "SET",1,"cs_set",CS_SET, "m" );
	FillLevel( &leveltable[11], "BAN",1,"cs_ban",CS_BAN, "m" );
	FillLevel( &leveltable[12], "BANME",1,"cs_banme",CS_BANME, "" );
	FillLevel( &leveltable[13], "CLEAR",1,"cs_clear",CS_CLEAR, "m" );
	FillLevel( &leveltable[14], "GETKEY",1,"cs_getkey",CS_GETKEY, "o" );
	FillLevel( &leveltable[15], "HALFOP",1,"cs_halfop",CS_HALFOP, "h" );
	FillLevel( &leveltable[16], "HALFOPME",1,"cs_halfopme",CS_HALFOPME, "h" );
	FillLevel( &leveltable[17], "INFO",1,"cs_info",CS_INFO, ".+" );
	FillLevel( &leveltable[18], "KICK",1,"cs_kick",CS_KICK, "o" );
	FillLevel( &leveltable[19], "KICKME",1,"cs_kickme",CS_KICKME, "o" );
	FillLevel( &leveltable[20], "INVITE",1,"cs_invite",CS_INVITE, "o" );
	FillLevel( &leveltable[21], "OPDEOP",1,"cs_opdeop",CS_OPDEOP, "o" );
	FillLevel( &leveltable[22], "OPDEOPME",1,"cs_opdeopme",CS_OPDEOPME, "o" );
	FillLevel( &leveltable[23], "PROTECT",1,"cs_protect",CS_PROTECT, "p" );
	FillLevel( &leveltable[24], "PROTECTME",1,"cs_protectme",CS_PROTECTME, "p" );
	FillLevel( &leveltable[25], "TOPIC",1,"cs_topic",CS_TOPIC, "t" );
	FillLevel( &leveltable[26], "UNBAN",1,"cs_unban",CS_UNBAN, "o" );
	FillLevel( &leveltable[27], "VOICE",1,"cs_voice",CS_VOICE, "v" );
	FillLevel( &leveltable[28], "VOICEME",1,"cs_voiceme",CS_VOICEME, "v" );
	FillLevel( &leveltable[29], "MEMO",1,"cs_memo",CS_MEMO, "o" );
	FillLevel( &leveltable[30], "ASSIGN",1,"cs_assign",CS_ASSIGN, "o" );
	FillLevel( &leveltable[31], "BADWORDS",1,"cs_badwords",CS_BADWORDS, "o" );
	FillLevel( &leveltable[32], "FANTASIA",1,"cs_fantasia",CS_FANTASIA, "o" );
	FillLevel( &leveltable[33], "GREET",1,"cs_greet",CS_GREET, "v" );
	FillLevel( &leveltable[34], "NOKICK",1,"cs_nokick",CS_NOKICK, "" );
	FillLevel( &leveltable[35], "SAY",1,"cs_say",CS_SAY, "o" );
	
	FillLevel( &leveltable[36], "h",2,"cs_halfop",CS_HALFOP, "h" );
	FillLevel( &leveltable[37], "o",2,"cs_opdeop",CS_OPDEOP, "o" );
	FillLevel( &leveltable[38], "p",2,"cs_protect",CS_PROTECT, "p" );
	FillLevel( &leveltable[39], "t",2,"cs_topic",CS_TOPIC, "t" );
	FillLevel( &leveltable[40], "v",2,"cs_voice",CS_VOICE, "v" );
	FillLevel( &leveltable[41], "ah",2,"cs_autohalfop",CS_AUTOHALFOP, "a*h" );
	FillLevel( &leveltable[42], "ao",2,"cs_autoop",CS_AUTOOP, "a*o" );
	FillLevel( &leveltable[43], "ap",2,"cs_autoprotect",CS_AUTOPROTECT, "a*p" );
	FillLevel( &leveltable[44], "av",2,"cs_autovoice",CS_AUTOVOICE, "a*v" );
	
	FillLevel( &leveltable[45], "SUCCESSOR",3,"",ACCESS_SUCCESSOR, "m" );
	FillLevel( &leveltable[46], "FOUNDER",3,"",ACCESS_FOUNDER, "n" );
	
	FillLevel( &leveltable[47], "m",4,"",ACCESS_SUCCESSOR, "m" );
	FillLevel( &leveltable[48], "n",4,"",ACCESS_FOUNDER, "n" );
	/*****************************************/

#ifdef USE_THREADS
	/***** Set Mutex Attributes *****/
	pthread_mutexattr_init(&limit_lock_attr);
	pthread_mutexattr_init(&dlog_lock_attr);
	pthread_mutexattr_init(&sqllog_lock_attr);
	pthread_mutexattr_init(&alog_lock_attr);
	pthread_mutexattr_init(&mail_lock_attr);
	pthread_mutexattr_init(&modules_read_lock_attr);
	pthread_mutexattr_init(&modules_lock_attr);
	pthread_mutexattr_init(&mysql_lock_attr);
	pthread_mutexattr_init(&quotelog_lock_attr);
	pthread_mutexattr_init(&mysqlbuffer_lock_attr);
	pthread_mutexattr_init(&users_lock_attr);
	pthread_mutexattr_init(&protocol_lock_attr);
	pthread_mutexattr_init(&backtrace_lock_attr);
	pthread_mutexattr_init(&stays_lock_attr);
	pthread_mutexattr_init(&substring_lock_attr);
	pthread_mutexattr_init(&trusts_lock_attr);
	pthread_mutexattr_init(&trustgroups_lock_attr);
	pthread_mutexattr_init(&ulines_lock_attr);
	pthread_mutexattr_init(&servers_lock_attr);
	pthread_mutexattr_init(&users_lock_attr);
	pthread_mutexattr_init(&thread_lock_attr);
	pthread_mutexattr_init(&globvar_lock_attr);
	pthread_mutexattr_init(&shconfig_lock_attr);
	pthread_mutexattr_init(&languages_lock_attr);

	pthread_mutexattr_init(&sockets_lock_attr);
	pthread_mutexattr_init(&sockread_lock_attr);
	pthread_mutexattr_init(&sockwrite_lock_attr);
	pthread_mutexattr_init(&threads_lock_attr);
	
	pthread_mutexattr_settype(&limit_lock_attr,PTHREAD_MUTEX_ERRORCHECK);
	pthread_mutexattr_settype(&dlog_lock_attr,PTHREAD_MUTEX_ERRORCHECK);
	pthread_mutexattr_settype(&sqllog_lock_attr,PTHREAD_MUTEX_ERRORCHECK);
	pthread_mutexattr_settype(&alog_lock_attr,PTHREAD_MUTEX_ERRORCHECK);
	pthread_mutexattr_settype(&mail_lock_attr,PTHREAD_MUTEX_ERRORCHECK);
	pthread_mutexattr_settype(&modules_read_lock_attr,PTHREAD_MUTEX_ERRORCHECK);
	pthread_mutexattr_settype(&modules_lock_attr,PTHREAD_MUTEX_ERRORCHECK);
	pthread_mutexattr_settype(&mysql_lock_attr,PTHREAD_MUTEX_ERRORCHECK);
	pthread_mutexattr_settype(&quotelog_lock_attr,PTHREAD_MUTEX_ERRORCHECK);
	pthread_mutexattr_settype(&mysqlbuffer_lock_attr,PTHREAD_MUTEX_ERRORCHECK);
	pthread_mutexattr_settype(&users_lock_attr,PTHREAD_MUTEX_ERRORCHECK);
	pthread_mutexattr_settype(&protocol_lock_attr,PTHREAD_MUTEX_ERRORCHECK);
	pthread_mutexattr_settype(&backtrace_lock_attr,PTHREAD_MUTEX_ERRORCHECK);
	pthread_mutexattr_settype(&stays_lock_attr,PTHREAD_MUTEX_ERRORCHECK);
	pthread_mutexattr_settype(&substring_lock_attr,PTHREAD_MUTEX_ERRORCHECK);
	pthread_mutexattr_settype(&trusts_lock_attr,PTHREAD_MUTEX_ERRORCHECK);
	pthread_mutexattr_settype(&trustgroups_lock_attr,PTHREAD_MUTEX_ERRORCHECK);
	pthread_mutexattr_settype(&ulines_lock_attr,PTHREAD_MUTEX_ERRORCHECK);
	pthread_mutexattr_settype(&servers_lock_attr,PTHREAD_MUTEX_ERRORCHECK);
	pthread_mutexattr_settype(&users_lock_attr,PTHREAD_MUTEX_ERRORCHECK);
	pthread_mutexattr_settype(&thread_lock_attr,PTHREAD_MUTEX_ERRORCHECK);
	pthread_mutexattr_settype(&globvar_lock_attr,PTHREAD_MUTEX_ERRORCHECK);
	pthread_mutexattr_settype(&shconfig_lock_attr,PTHREAD_MUTEX_ERRORCHECK);
	pthread_mutexattr_settype(&languages_lock_attr,PTHREAD_MUTEX_ERRORCHECK);

	pthread_mutexattr_settype(&sockets_lock_attr,PTHREAD_MUTEX_ERRORCHECK);
	pthread_mutexattr_settype(&sockread_lock_attr,PTHREAD_MUTEX_ERRORCHECK);
	pthread_mutexattr_settype(&sockwrite_lock_attr,PTHREAD_MUTEX_ERRORCHECK);
	pthread_mutexattr_settype(&threads_lock_attr,PTHREAD_MUTEX_ERRORCHECK);
	/****************************/
	
	
	/***** Mutex Initialize *****/
	pthread_mutex_init(&limit_lock			, &limit_lock_attr);
	pthread_mutex_init(&dlog_lock			, &dlog_lock_attr);
	pthread_mutex_init(&sqllog_lock			, &sqllog_lock_attr);
	pthread_mutex_init(&alog_lock			, &alog_lock_attr);
	pthread_mutex_init(&mail_lock			, &mail_lock_attr);
	pthread_mutex_init(&modules_read_lock	, &modules_read_lock_attr);
	pthread_mutex_init(&modules_lock		, &modules_lock_attr);
	pthread_mutex_init(&mysql_lock			, &mysql_lock_attr);
	pthread_mutex_init(&quotelog_lock		, &quotelog_lock_attr);
	pthread_mutex_init(&mysqlbuffer_lock	, &mysqlbuffer_lock_attr);
	pthread_mutex_init(&users_lock			, &users_lock_attr);
	pthread_mutex_init(&protocol_lock		, &protocol_lock_attr);
	pthread_mutex_init(&backtrace_lock		, &backtrace_lock_attr);
	pthread_mutex_init(&stays_lock			, &stays_lock_attr);
	pthread_mutex_init(&substring_lock		, &substring_lock_attr);
	pthread_mutex_init(&trusts_lock			, &trusts_lock_attr);
	pthread_mutex_init(&trustgroups_lock	, &trustgroups_lock_attr);
	pthread_mutex_init(&ulines_lock			, &ulines_lock_attr);
	pthread_mutex_init(&servers_lock		, &servers_lock_attr);
	pthread_mutex_init(&users_lock			, &users_lock_attr);
	pthread_mutex_init(&thread_lock			, &thread_lock_attr);
	pthread_mutex_init(&globvar_lock		, &globvar_lock_attr);
	pthread_mutex_init(&shconfig_lock		, &shconfig_lock_attr);
	pthread_mutex_init(&languages_lock		, &languages_lock_attr);

	pthread_mutex_init(&sockets_lock		, &sockets_lock_attr);
	pthread_mutex_init(&sockread_lock		, &sockread_lock_attr);
	pthread_mutex_init(&sockwrite_lock		, &sockwrite_lock_attr);
	pthread_mutex_init(&threads_lock		, &threads_lock_attr);
	/****************************/
#endif

	NewTData					("IRC");
	Threads *thread = SeekThread("IRC");
	IRCThread 		= thread;
	
#ifdef USE_THREADS
	pthread_attr_init(&thread->attr);
	pthread_attr_setdetachstate(&thread->attr, PTHREAD_CREATE_DETACHED);
#endif
	
#ifdef USE_THREADS
	if(THREAD_SAFE)
    	my_init();
#endif

#ifndef _WIN32
    /* If we're root, issue a warning now */
    if ((getuid() == 0) && (getgid() == 0)) {
        fprintf(stderr,
                "WARNING: You are currently running [%s - codename %s, %s] as the root superuser. %s does not\n",MAINPROJECT,PROJECTNAME,VERSION_NUMBER,PROJECTNAME);
        fprintf(stderr,
                "    require root privileges to run, and it is discouraged that you run %s\n",PROJECTNAME);
        fprintf(stderr, "    as the root superuser.\n");
    }
#endif

	bzero(&linkserver,sizeof(linkserver));
	bzero(&global_target,sizeof(global_target));
	bzero(&IRC,sizeof(IRC));
	bzero(&WebForm,sizeof(WebForm));
    zero_config_values(thread);
    InitializeSharedLanguages();
    
	/*m = &copyconfig;
	Q = &Q_conf_l;
	O = &O_conf_l;
	SC = &sc_conf_l;
	ns = &ns_conf_l;
	cs = &cs_conf_l;
	hs = &hs_conf_l;
	ms = &ms_conf_l;
	bs = &bs_conf_l;
	g  = &g_conf_l;*/
	
	/* Loades the Config */
	loadconf(thread,"services");
	if(parse_options(ac,av)==-1) exit(0);
	
	serverid = m->serverlink;
	
	/* Opens the Logfiles */
	/*** Logging Files and Channels - Initialize Logging ***/
	    if(m->logfile[0]!='\0' && logging==0) logging    = 1;
	    if(m->logchan[0]!='\0' && logchan==0) logchan    = 1;
	    if(m->sqllogfile[0]!='\0')            sqllogging = 1;
	    
	    if(m->freelogs){
	        remove_logs(thread);
	        remove(m->logquotes);
	    }
	    
	    if(debugbylog){
    		if(logging)
                strunshift("REPLAY",m->logfile,sizeof(m->logfile));
    		if(sqllogging)
                strunshift("REPLAY",m->sqllogfile,sizeof(m->sqllogfile));
    		if(m->debuglogging)
                strunshift("REPLAY",m->debuglog,sizeof(m->debuglog));
		}
		
	    open_logs(thread);
	    
	    if(m->logquotes[0]!='\0') quotelog     = fopen(m->logquotes ,"a+");
	/******************************************************/

	/* Initializes the Languages */
	init_langs(thread);

	/* Deleting commands - showcommands */
	modules=getmodules(thread); // Loades Modules

	/* Proof Config */
	int debug = m->debug;
	if(m->debug < 1)
		m->debug = 1;
	
	if(proof_config(thread)==0){
		dlog(thread,0,
			"  *  ERROR: You haven't defined a required variable in the config file, check all variables that are \"REQUIRED\", and restart\n"
			"You find further information in the log (normal log file)!\n"
			);
		exit(0);
	}
	m->debug = debug;
	
	/* Check the Pidfile */
	check_pidfile();
	printf(" [*] Config Loaded...\n");
	
	mysql_connect(thread); /* Start Connection to the mysql server */

/* Free Tables before INSERTING, UPDATING, SELECTING from them */

    	if(m->MySQLSuperUser){
    		domysql(thread,"SET GLOBAL `table_cache`=10000");
    		domysql(thread,"SET GLOBAL `query_cache_size`=50000000");
		}

	/* Free Tables before INSERTING, UPDATING, SELECTING from them */
		domysql(thread,"TRUNCATE `orion_core_condata`");
		domysql(thread,"TRUNCATE `orion_chan_users`");
		domysql(thread,"TRUNCATE `orion_core_commands`");
		domysql(thread,"TRUNCATE `orion_core_config_ro`");
		
		domysql(thread,"TRUNCATE `orion_core_condata_log`");
		domysql(thread,"TRUNCATE `orion_core_condata_tmp`");
		domysql(thread,"TRUNCATE `orion_core_servers`");
		domysql(thread,"TRUNCATE `orion_core_lines`");
		
		domysql(thread,"DELETE FROM `orion_chan_bans`");
		domysql(thread,"DELETE FROM `orion_chan_expbans`");
		domysql(thread,"DELETE FROM `orion_ns_aliases` WHERE `linked`='1'");
		domysql(thread,"DELETE FROM `orion_cs_core` WHERE `serv`=''");
		domysql(thread,"UPDATE `orion_ns_aliases` SET `active`='0' WHERE `linked`='0'");
		domysql(thread,"UPDATE `orion_cs_core` SET `datecreate`=''");
	
		if(m->MySQLSuperUser){
			domysql(thread,"FLUSH QUERY CACHE");
			domysql(thread,"RESET QUERY CACHE");
		}
	/* Since we are now connected to the MySQL-Server, we load the trusts to Memory - we dump it there
	 * because the memory is faster 
	 */ 
		GetTrustsSql(thread);
		GetTrustgroupsSql(thread);
			
		/* Dump the Configfile to MySQL */
		if(m->UseWebForm)
			dumpconf_mysql(thread);
			
		printf(" [*] MySQL updated...\n\n");
	/***************************************************************/
	
	if(!LoadProtocol(thread,&IRC,m->protocol)){
		dlog(thread,0,"  *  ERROR: Loading IRCd Config Failed (services exited)...\n");
		_orion_exit();
	}

	/* load default encryption */
	ModErr = OrionLoadModule(thread,_dynadd("enc_%s",m->encrypt)).ModErr;
	if(ModErr != MOD_ERR_OK){
		dlog(thread,0,"  *  ERROR: Loading Encryption Module (Check the Config!)...\n");
		dlog(thread,0,"  *  ERROR: %s\n",ModuleError(ModErr));
		_orion_exit();
	}
	
	//DumpModules(thread);
	
	/* load new encryption, if we have one */
	if(m->NewEncrypt[0]!='\0'){
		ModErr = OrionLoadModule(thread,_dynadd("enc_%s",m->NewEncrypt)).ModErr;
		if(ModErr != MOD_ERR_OK){
			dlog(thread,0,"  *  ERROR: Loading NewEncryption Module (Check the Config!)...\n");
			dlog(thread,0,"  *  ERROR: %s\n",ModuleError(ModErr));
			_orion_exit();
		}
	}
	
	if(!LoadProtocol(thread,&WebForm,"WebForm")){
		dlog(thread,0,"  *  ERROR: Loading WebForm Protocol Failed (services exited)...\n");
		_orion_exit();
	}

	i = 0;
	/************** Load the Modules (Service Bots) *****************/
	while(i<modules){
		if(modul[i][0]!='\0'){
			load_modules(thread,modul[i]); //Loads the Modules
		}
		i++;
	}

	//LOAD MAIN CLIENT - DO NOT EDIT THIS
	load_modules(thread,"orion");
	/****************************************************************/
	
	printf("\n [*] Modules Loaded...\n");
	
	/************ Check for Thread Processes to start Up ************/
#ifdef USE_THREADS
	if(THREAD_SAFE){
		if(m->UseWebForm)
			printf(" [*] WebForm Server running (Single Threaded)...\n");
		else
			printf("  *  NOTIFICATION: WebForm Server NOT running! (Setting specified in the Config)\n");
	}else printf("  *  NOTIFICATION: WebForm Server NOT running! (Project NOT Thread-safe)\n");
#else
	if(m->UseWebForm)
		printf(" [*] WebForm Server running...\n");
	else
		printf("  *  NOTIFICATION: WebForm Server NOT running! (Setting specified in the Config)\n");
#endif
	/****************************************************************/
	
#ifdef THREAD_PROCESSES
	printf("\n [*] %s running (Multi-Threaded architecture)...\n",VERSION);
#else
	printf("\n [*] %s running...\n",VERSION);
#endif
	printf("  *  %s (C)%s [compiled %s %s]\n",PROJECTNAME,YEAR,__DATE__, __TIME__);
	printf("  *  For further Information use ./services -help\n");
	
	if(debugbylog){
		printf(" [*] Running in log-reading Debug (no connection to server will be established)\n");
	}
	
	mysql_disconnect(thread); /* Disconnection from the mysql server */

#ifndef _WIN32
  #ifdef HAVE_FORK
    if (dofork/* && !m->debug*/) {
		dlog(thread,3,"forking\n");
       if ((i = fork()) < 0) {
          perror("fork()");
          return -1;
       } else if (i != 0) {
          exit(0);
       }
        if (started_from_term) {
            fclose(stdin);
            fclose(stderr);
            fclose(stdout);
        }
        if (setpgid(0, 0) < 0) {
            perror("setpgid()");
            return -1;
        }
    }
  #endif
#else
    /* Initialize winsocks -- codemastr */
    {
        WSADATA wsa;
        if (WSAStartup(MAKEWORD(1, 1), &wsa)) {
            alog(thread,"Failed to initialized WinSock library\n");
            return -1;
        }
    }
    if (!SupportedWindowsVersion()) {
        char *winver = GetWindowsVersion();
        alog(thread,"%s is not a supported version of Windows\n", winver);
        free(winver);
        return -1;
    }
    if (dofork) {
        //printf("Launching Orion into the background\n");
        FreeConsole();
    }
#endif

	write_pidfile(); // write our pidfile!

    if (m->debug || readonly) {
        alog(thread,"%s version %s [%s] (ircd protocol: %s) starting up (options:%s%s)\n",
             PROJECTNAME, VERSION_NUMBER, VERSION, m->protocol,
             m->debug ? " debug" : "", readonly ? " readonly" : "");
    } else {
        alog(thread,"%s version %s [%s] (ircd protocol: %s) starting up\n",
             PROJECTNAME, VERSION_NUMBER, VERSION, m->protocol);
    }
    
    if (readonly){
        fclose(thread->loghandle);
        fclose(thread->sqlloghandle);
        fclose(quotelog);
        logging    = 0;
        sqllogging = 0;
    }

	mysql_connect(thread); /* Start Connection to the mysql server */
	sleep(3);
	
	/************* Initialize MySQL's Session Variables *************/
	
    domysql(thread,"SET SESSION `max_heap_table_size`=150000000");
    domysql(thread,"SET SESSION `tmp_table_size`=300000000");
    domysql(thread,"SET SESSION `max_tmp_tables`=500");

    /* This helps sockscontrol with big data fields */
	domysql(thread,"SET SESSION `group_concat_max_len`=16384");
    domysql(thread,"SET SESSION `query_alloc_block_size`=%d",MYSQL_SET_BUF);

	/**************** Thread Processes starting Up ******************/
#ifdef USE_THREADS
	if((THREAD_SAFE)){
		if(m->UseWebForm){
			NewThread("WebForm",WebSocket);
		}
	}
#endif
	/****************************************************************/

    if (!dofork) {
		dlog(thread,3,"signal(SIGINT, sighandler);\n");
        signal(SIGINT, sighandler);
    } else {
		dlog(thread,3,"signal(SIGINT, SIG_DFL);\n");
        signal(SIGINT, SIG_DFL);
    }

    signal(SIGTERM, sighandler);
    signal(SIGQUIT, sighandler);
    signal(SIGSEGV, sighandler);
    
#ifndef _WIN32
    signal(SIGBUS, sighandler);
    signal(SIGTRAP, sighandler);
#endif

    signal(SIGHUP, sighandler);

#ifndef _WIN32
    signal(SIGUSR2, sighandler);
#endif
    
#ifdef SIGIOT
    signal(SIGIOT, sighandler);
#endif

    signal(SIGFPE, sighandler);

#if !defined(USE_THREADS) || !defined(LINUX20)
#ifndef _WIN32
    signal(SIGUSR1, sighandler);        /* This is our "out-of-memory" panic switch */
#endif
#endif

/***** RESET Traffic *****/
	m->TrafficIn_bps  = 0;
	m->TrafficIn      = 0;
	m->TrafficOut     = 0;
	m->TrafficOut_bps = 0;
/*************************/

/** Connect to the Server and start Main - loop / So Lets keep rocki'n **/
	if(IRC.p10protocol)
		m->Numeric = "AA";
	/*if(IRC.p10new)
		m->Numeric = "00A";*/
	
	m->starttime     = time(NULL); /* Update our starttime */
   	sqldumptime      = time(NULL); /* Update our SQL-Dumptime */
   	LimitRefreshTime = time(NULL); /* Update our Limit Refresh Time */
   	ExpireCheckTime  = time(NULL); /* Update our Expire Check Time */
   	PingCheckTime    = time(NULL); /* Update our Ping Check Time - so we can't get disconnected! */
   	LastNickCheck    = time(NULL); /* Update our NickName check */
   	LastUsedCheck    = time(NULL); /* Update our NickName Last Used time */
   	StayRefreshTime  = time(NULL); /* Update our StayTime - Manages Bot's and ChanServ to stay in Channel longer */
   	TrafficCalcTime  = time(NULL); /* Update our TrafficTime - Manages Traffic modes */
   	srand(time(NULL));			   /* Initialize the Randomgenerator */
   	MySQL_CleanInserts(0,MAX_BUFFER_TABLES);
   	
	thread->Sock = startlink(thread,m->server,m->port,m->bindServicesIp[0]!='\0' ? m->bindServicesIp : NULL,0); //Starts connecting the Server
#ifdef USE_THREADS
	IRCSock = thread->Sock;
#endif

		/* This is the process which helps orion to check things periodically */
#ifdef THREAD_PROCESSES
    if(THREAD_SAFE){
		NewThread("ValidateNicks",TValidatenicks);
		NewThread("CheckMiscStuff",TCheckMiscStuff);
		NewThread("Expiration",TExpiration);
		
		/* Custom Thread */
		size_t stacksize;

		Threads *ThreadSockscontrol = NewTData("SocksControl");
		pthread_attr_getstacksize(&ThreadSockscontrol->attr, &stacksize);
 		//dlog(thread,0,"Default stack size = %li\n", stacksize);
		stacksize = stacksize*4;
		//dlog(thread,0,"Amount of stack needed per thread = %li\n",stacksize);
		pthread_attr_setstacksize (&ThreadSockscontrol->attr, stacksize);
		
		/* Start our custom thread */
		RunThread(ThreadSockscontrol, TSockscontrol);
	}
#endif

/** Start Webform if we don't use threads but we want to start it anywayz **/
#ifndef USE_THREADS
	NewTData("Webform");
	Threads *WebFormSocketThread = SeekThread("Webform");

	/* maximum file descriptor number */
	orion_socket_t 	fdmax           = 0;

	/* for setsockopt() SO_REUSEADDR, below */
	const char		yes				= 1;
	int    			web_read		= 0;
	orion_socket_t	save_fd			= 0;
	orion_socket_t  SockIterator	= 0;
#ifdef _WIN32
	int addrsize;
#else
	unsigned int addrsize;
#endif
	/****************************************/

	if(m->UseWebForm){

		/* Open our logfiles for the Thread */
		open_logs(WebFormSocketThread);

		/* Indicate that it's the WebForm application */
		WebFormSocketThread->Webform = true;

		/* clear the master and temp sets */
		FD_ZERO(&master);
		FD_ZERO(&read_fds);

		/* get the listener */
		if((WebFormSocketThread->MSock = socket(AF_INET, SOCK_STREAM, 0)) == -1){
			dlog(WebFormSocketThread,0,"  *  ERROR: WebForm - Server-socket() failed to establish connection\n");
		}

		/* "address already in use" error message */
		if(setsockopt(WebFormSocketThread->MSock, SOL_SOCKET, SO_REUSEADDR, &yes, sizeof(int)) == -1){
			dlog(WebFormSocketThread,0,"  *  ERROR: WebForm - Server-setsockopt()\n");
		}
		dlog(WebFormSocketThread,0," [*] WebForm - Server-setsockopt() is OK...\n");

		/* bind */
#if HAVE_GETHOSTBYNAME
    	struct hostent *hp;
#else
    	char *addr;
#endif
		if(m->bindWebFormIp[0]!='\0'){
#if HAVE_GETHOSTBYNAME
 	   		if ((hp = gethostbyname(m->bindWebFormIp)) != NULL) {
        		memcpy((char *) &serveraddr.sin_addr, hp->h_addr, hp->h_length);
            	serveraddr.sin_family = hp->h_addrtype;
			}
#else
        	if (addr = pack_ip(m->bindWebFormIp)) {
           		memcpy((char *) &serveraddr.sin_addr, addr, 4);
            	serveraddr.sin_family = AF_INET;
			}
#endif
		}else{
			serveraddr.sin_family = AF_INET;
			serveraddr.sin_addr.s_addr = INADDR_ANY;
		}
		serveraddr.sin_port = htons(m->WebPort);
		memset(&(serveraddr.sin_zero), '\0', 8);

		if(bind(WebFormSocketThread->MSock, (struct sockaddr *)&serveraddr, sizeof(serveraddr)) != -1)
			dlog(WebFormSocketThread,0," [*] WebForm - Server-bind() is OK...\n");

		/* listen */
		if(listen(WebFormSocketThread->MSock, 10) == -1)
			dlog(thread,0,"  *  ERROR: WebForm - Server-listen() error!\n");

		dlog(WebFormSocketThread,0," [*] WebForm - Server-listen() is OK...\n");

#ifndef _WIN32
		save_fd = fcntl( WebFormSocketThread->MSock, F_GETFL );
		save_fd |= O_NONBLOCK;
		fcntl( WebFormSocketThread->MSock, F_SETFL, save_fd );
#else
		WebFormSocketThread->MSock =  orion_socksetnonb(save_fd);
#endif

		dlog(WebFormSocketThread,0," [*] WebForm - Server NONBLOCKING is OK...\n");

		/* add the listener to the master set */
		FD_SET(WebFormSocketThread->MSock, &master);

		/* keep track of the biggest file descriptor */
		fdmax = WebFormSocketThread->MSock; /* so far, it's this one*/
	}
#endif

	while(1){
/** Execute our Processes **/

#ifndef THREAD_PROCESSES
/* P1 */if(PingCheckTime+90<=time(NULL) && DuringServerlink){
			if(linkserver[0]!='\0')
				orion_WRCtranslate_cmd_pong(thread,m->servername,linkserver);
				
			PingCheckTime = time(NULL);
		}

		/* Sockscontrol Process - Poll time */
		if(!debugbylog)
/* P2 */	_ExecuteEvent(NULL,NULL,"socks_check");
    	
    	/* Dumping from the Database to memory in a period of 30 minutes! */
/* P3 */if(sqldumptime+m->TrustDumpTime<=time(NULL) && !DuringServerlink){
		 	//In that case it's time for flushing the memory, with new DB-data
			//Delete out of memory
			dlog(thread,0,"--- flushing sql trusts ---\n");
			DelTrustgroups(); 	/* Clear Trustgroups - In the memory */
			DelTrusts(); 		/* Clear Trusts - In the memory */
			
			if(m->MySQLSuperUser){
				domysql(thread,"FLUSH QUERY CACHE");
				domysql(thread,"RESET QUERY CACHE");
			}
			
			//Insert in the memory again - Dumping
			GetTrustsSql(thread);
			GetTrustgroupsSql(thread);
			
			//Done we have to increase the "sqldumptime"
			sqldumptime=time(NULL);
		} /* Flushing memory with new data done, executing other Processes */
		
/* P4 */if(StayRefreshTime+m->CSStayChannel<=time(NULL) && !DuringServerlink){
			PerformStay(thread);
			StayRefreshTime=time(NULL);
		}
		
/* P5 */if(LimitRefreshTime+m->LimitCheck<=time(NULL) && !DuringServerlink){ /* Change Limits for Q-Channels where a join,part,quit or something occured */
			PerformLimits(thread);
			delLimits(thread);
			LimitRefreshTime=time(NULL);
		}
		
/* P6 */if(LastUsedCheck+m->NickUsedCheck<=time(NULL) && !DuringServerlink){ /* Change Last Used state (before Expiring Groups) - to avoid Bouncer Expiring */
			domysql(thread,"UPDATE `orion_ns_aliases` LEFT OUTER JOIN `orion_cs_access` ON `orion_cs_access`.`authnick`=`orion_ns_aliases`.`display` LEFT OUTER JOIN `orion_cs_core` ON `orion_cs_core`.`channel`=`orion_cs_access`.`channel` SET `orion_ns_aliases`.`last_used`='%ld', `orion_cs_core`.`last_used`='%ld' WHERE `orion_ns_aliases`.`active`='1'",time(NULL),time(NULL));
			LastUsedCheck=time(NULL);
		}
		
/* P7 */if(ExpireCheckTime+m->ExpireCheckTime<=time(NULL) && !DuringServerlink){
#if MAX_CHANNELNAME_LEN > MAX_NICK_LEN
			char anickchan[MAX_CHANNELNAME_LEN*2];
			char nick     [MAX_NICK_LEN*2];
#else
			char anickchan[MAX_NICK_LEN*2];
			char nick     [MAX_NICK_LEN*2];
#endif
			char chan_delete[MAX_CHANNELNAME_LEN*70];
			char chan_update[MAX_CHANNELNAME_LEN*70];
			char channel_all[MAX_CHANNELNAME_LEN*70*2];
			char groupnicks[MAX_NICK_LEN*70];
			char *nickgroup[300];
			
			time_t gettime    		= 0;
			time_t usrexpire  		= 0;
			time_t reqexpire  		= 0;
			time_t chanexpire 		= 0;
			int j					= 0;
			size_t a				= 0;
			int lastgroupmember		= 0;
			bool expiremain  		= 0;

			deepSQL getSQL[2];
			bzero(&getSQL    ,sizeof(getSQL));
			bzero(&anickchan ,sizeof(anickchan));
			bzero(&nick      ,sizeof(nick));
			
			bzero(&chan_delete      ,sizeof(chan_delete));
			bzero(&chan_update      ,sizeof(chan_update));
			bzero(&channel_all      ,sizeof(channel_all));
			bzero(&groupnicks       ,sizeof(groupnicks));
			bzero(nickgroup         ,sizeof(nickgroup));
	
			gettime    = time(NULL);
			reqexpire  = gettime - m->NSRExpire;
			usrexpire  = gettime - expire(m->NSExpire);
			chanexpire = gettime - expire(m->CSExpire);
	
			getSQL[0].res    = doSelectMySQL(thread,
				"SELECT DISTINCT "
					"`orion_ns_aliases`.`display`,"
					"`orion_ns_aliases`.`nick`,"
					"`orion_ns_aliases`.`last_used`,"
 
					"SUM("
						"IF(`orion_ns_aliases`.`expire`='1' AND `orion_ns_aliases`.`last_used` <= '%ld',1,0)" // usrexpire
					") AS `count_expire`,"
					
					"COUNT(DISTINCT `orion_ns_aliases`.`nick`) AS `groupmembers`,"
					
					"GROUP_CONCAT(DISTINCT "
										"`orion_ns_aliases`.`nick` ORDER BY `orion_ns_aliases`.`expire` DESC,"
										"`orion_ns_aliases`.`last_used` ASC"
					") AS `nicks_sorted`,"

					"`orion_ns_core`.`email`,"
					"`orion_ns_core`.`settings`,"

					"("
					
						"SELECT "
							"GROUP_CONCAT(`channel`) FROM `orion_cs_core` AS `core2` "
							
						"WHERE "
							"`core2`.`successor`=`orion_ns_aliases`.`display` OR "
							"`core2`.`founder`=`orion_ns_aliases`.`display`"
							
					") AS `role_in_channel` "
					
					"FROM `orion_ns_aliases` "
						"LEFT OUTER JOIN `orion_ns_core` ON `orion_ns_aliases`.`display` = `orion_ns_core`.`authnick` "
						
				"WHERE "
					"`orion_ns_aliases`.`forbid`='0' AND "
					"`orion_ns_aliases`.`linked`='0' "
				
				"GROUP BY "
					"`orion_ns_aliases`.`display` "
				
				"HAVING "
					"SUM("
						"IF(`orion_ns_aliases`.`expire`='1' AND `orion_ns_aliases`.`last_used` <= '%ld',1,0)" // usrexpire
					")>0 "
				"ORDER BY `orion_ns_aliases`.`display` ASC",
				usrexpire,usrexpire
			);
			
			getSQL[0].fields = mysql_num_rows(getSQL[0].res);
			if(getSQL[0].fields){
				
				for(i=0;i<getSQL[0].fields;i++){
					getSQL[0].row = mysql_fetch_row(getSQL[0].res);
					
					if(stoi(getSQL[0].row[7])&NS_SUSPENDED)
						continue;
					
					bzero(&anickchan,sizeof(anickchan));
					bzero(&nick,sizeof(nick));
					
					mysql_real_escape_string(MYSQL_CONNECTION_HANDLE, anickchan, getSQL[0].row[0], strlen(getSQL[0].row[0]));
					mysql_real_escape_string(MYSQL_CONNECTION_HANDLE, nick, getSQL[0].row[1], strlen(getSQL[0].row[1]));
					
					if(stoi(getSQL[0].row[4])-stoi(getSQL[0].row[3])==0){
						/* Expire a complete NickGroup, since the Group has only a single Nick in it and that one expires - that's a pitty =/ */
						do_logchan(thread,NULL,NULL,NULL,NULL,"Expiring Nickgroup of %s (group: %s) (e-mail: %s) [Last Used on: %s]",getSQL[0].row[1],getSQL[0].row[0],getSQL[0].row[6],get_localtime(atol(getSQL[0].row[2])));
						
						domysql(thread,"DELETE `orion_ns_core`,`orion_ms_core` FROM `orion_ns_core` LEFT OUTER JOIN `orion_ms_core` ON (`orion_ms_core`.`receiver`=`orion_ns_core`.`authnick`) WHERE `orion_ns_core`.`authnick`='%s'",anickchan);
						if(getSQL[0].row[8]!=NULL)
							domysql(thread,"UPDATE `orion_cs_core` SET `founder`=IF(`founder`='%s',IF(`successor`='%s',NULL,`successor`),`founder`),`last_used`=IF(IF(`founder`='%s',IF(`successor`='%s',NULL,`successor`),`founder`) IS NOT NULL, `last_used`, '0'),`successor`=NULL WHERE `channel` IN ('%s')",anickchan,anickchan,anickchan,anickchan,getSQL[0].row[8]);

					}else if(stoi(getSQL[0].row[4])-stoi(getSQL[0].row[3])>0){
						lastgroupmember = stoi(getSQL[0].row[4])-1;
						/* Expire the Nicknames */
						//do_logchan(thread,NULL,NULL,NULL,NULL,"Expiring nickname %s (group: %s) (e-mail: %s) [Last Used on: %s]",getSQL[0].row[1],getSQL[0].row[0],getSQL[0].row[6],get_localtime(atol(getSQL[0].row[2])));
						dynncpy(groupnicks,getSQL[0].row[5],sizeof(groupnicks));
						a = strsplit(groupnicks,nickgroup,',');
						for(j=0;j<stoi(getSQL[0].row[3]);j++){
							if(!streqnc(nickgroup[j],getSQL[0].row[0])){
								domysql(thread,"DELETE FROM `orion_ns_aliases` WHERE `nick`='%s'",mysql_quote(thread,nickgroup[j]));
								do_logchan(thread,NULL,NULL,NULL,NULL,"Expiring nickname %s (group: %s) (e-mail: %s) [Last Used on: %s]",nickgroup[j],getSQL[0].row[0],getSQL[0].row[6],get_localtime(atol(getSQL[0].row[2])));
							}
							else{
								expiremain=1;
							}
						}
						
						if(expiremain){
							//domysql(thread,"DELETE `orion_ns_aliases`,`orion_hs_core` FROM `orion_ns_aliases` LEFT OUTER JOIN `orion_hs_core` ON (`orion_hs_core`.`nick`=`orion_ns_aliases`.`nick`) WHERE `orion_ns_aliases`.`nick`='%s'",nick);
							
							/* orion_hs_core done with cascade update / delete */
							domysql(thread,"DELETE FROM `orion_ns_aliases` WHERE `nick`='%s'",anickchan);
							domysql(thread,"UPDATE `orion_ns_core` LEFT OUTER JOIN `orion_ms_core` ON (`orion_ms_core`.`receiver`=`orion_ns_core`.`authnick`) SET `orion_ns_core`.`authnick`='%s',`orion_ms_core`.`receiver`='%s' WHERE `orion_ns_core`.`authnick`='%s'",mysql_quote(thread,nickgroup[lastgroupmember]),mysql_quote(thread,nickgroup[lastgroupmember]),anickchan);

							/* Changing Display - Since old Display expired! */
							do_logchan(thread,NULL,NULL,NULL,NULL,"Changed Display from %s (group: %s) to %s -> (NewGroupID: %s) (e-mail: %s)",getSQL[0].row[0],getSQL[0].row[0],nickgroup[lastgroupmember],nickgroup[lastgroupmember],getSQL[0].row[6]);
						}
						
						expiremain=0;
					}
				}
			}
			/* free result */
			mysql_free_result_myr(getSQL[0].res);
			
			getSQL[1].res    = doSelectMySQL(thread,"SELECT `orion_cs_core`.`channel`,(COUNT(`orion_chan_users`.`nick`)-SUM(IF(`orion_chan_users`.`nick`=`orion_cs_core`.`botnick`,1,0))) as `users`, `orion_cs_core`.`botnick` ,SUM(IF(`orion_chan_users`.`nick`=`orion_cs_core`.`botnick`,1,0)) as `botinchan`, `orion_cs_core`.`serv`, `orion_cs_core`.`datecreate`, `orion_cs_core`.`founder`, `orion_cs_core`.`settings` FROM `orion_cs_core` LEFT JOIN `orion_chan_users` ON `orion_chan_users`.`channel` = `orion_cs_core`.`channel` WHERE `orion_cs_core`.`serv`<>'' AND `last_used` <= '%d' AND `orion_cs_core`.`expire`='1' GROUP BY `orion_cs_core`.`channel`",chanexpire);
			getSQL[1].fields = mysql_num_rows(getSQL[1].res);
			if(getSQL[1].fields){
				for(i=0;i<getSQL[1].fields;i++){
					getSQL[1].row = mysql_fetch_row(getSQL[1].res);
					
					if(stoi(getSQL[1].row[7])&CS_SUSPEND_BIT)
						continue;
					if(stoi(getSQL[1].row[7])&CS_FORBID_BIT)
						continue;	
					
					int count_users_offset = 0;
					/* We proof if channel had inhabitant set and ChanServ is really in (if he is in we higher the user_count offset) */
					if(stoi(getSQL[1].row[7])&CS_INHABIT_BIT){
						Users 		*my_chanserv 		= GetUser(cs->nick);
						Uchannels 	*my_chanserv_channel= NULL;

						if(my_chanserv!=NULL)
							my_chanserv_channel = GetUserChannel(my_chanserv,thread->c.chan.name);

						/* WOOHOOO ChanServ isn't in the Channel yet */
						if(my_chanserv_channel!=NULL && my_chanserv_channel->isin_chan){
                            count_users_offset++;
						}
					}
					
					/* We proof if channel is a Q channel and Q is really in (if he is in we higher the user_count offset) */
					else if(streqnc(getSQL[1].row[4],"q")){
						Users 		*my_chanserv 		= GetUser(Q->nick);
						Uchannels 	*my_chanserv_channel= NULL;

						if(my_chanserv!=NULL)
							my_chanserv_channel = GetUserChannel(my_chanserv,thread->c.chan.name);

						/* WOOHOOO ChanServ isn't in the Channel yet */
						if(my_chanserv_channel!=NULL && my_chanserv_channel->isin_chan){
                            count_users_offset++;
						}
					}
					
					/* wenn getSQL[1].row[1] = 0  -> liste zusammenstellen mit allen zu lschenden channels -> ('#channel1','#channel2') */
					/* wenn getSQL[1].row[1] > 0  -> liste zusammenstellen mit allen zu nicht zu lschenden channels (nur update) -> ('#channel1','#channel2') */
					if(stoi(getSQL[1].row[1])==count_users_offset){
						straddnc(chan_delete,(char)39,sizeof(chan_delete));
						straddns(chan_delete,mysql_quote(thread,getSQL[1].row[0]),sizeof(chan_delete));
						straddnc(chan_delete,(char)39,sizeof(chan_delete));
						straddnc(chan_delete,',',sizeof(chan_delete));
					}else if(stoi(getSQL[1].row[1])>count_users_offset){
						straddnc(chan_update,(char)39,sizeof(chan_update));
						straddns(chan_update,mysql_quote(thread,getSQL[1].row[0]),sizeof(chan_update));
						straddnc(chan_update,(char)39,sizeof(chan_update));
						straddnc(chan_update,',',sizeof(chan_update));
					}
					
					if(stoi(getSQL[1].row[7])&CS_INHABIT_BIT)
					    orion_WRCtranslate_cmd_part(thread,cs->nick,getSQL[1].row[0],"channel expired");
                    else if(streqnc(getSQL[1].row[4],"q"))
					    orion_WRCtranslate_cmd_part(thread,Q->nick,getSQL[1].row[0],"channel expired");
					
					if(getSQL[1].row[2]!=NULL && stoi(getSQL[1].row[3])==1){
						do_rawmode(thread,getSQL[1].row[2],getSQL[1].row[0],stol(getSQL[1].row[5]) == 0 ? time(NULL) : stol(getSQL[1].row[5]),IRC.ModeOnChannelDrop);
						orion_WRCtranslate_cmd_part(thread,getSQL[1].row[2],getSQL[1].row[0],"channel expired");
					}
					else if(getSQL[1].row[2]==NULL || stoi(getSQL[1].row[3])==1){
						if(streqnc(getSQL[1].row[4],"chanserv")) do_rawmode(thread,cs->nick,getSQL[1].row[0],stol(getSQL[1].row[5]) == 0 ? time(NULL) : stol(getSQL[1].row[5]),IRC.ModeOnChannelDrop);
						else if(streqnc(getSQL[1].row[4],"q"))	do_rawmode(thread,Q->nick,getSQL[1].row[0],stol(getSQL[1].row[5]) == 0 ? time(NULL) : stol(getSQL[1].row[5]),IRC.ModeOnChannelDrop);
					}
					/* Channel Expires */
					if(getSQL[1].row[6]!=NULL)
						do_logchan(thread,NULL,NULL,NULL,NULL,"Expiring channel %s (founder: %s)",getSQL[1].row[0],getSQL[1].row[6]);

				}
				
				a=dynlen(chan_update);
				
				if(a>0) chan_update[a-1]='\0';
					a=dynlen(chan_delete);
				if(a>0) chan_delete[a-1]='\0';
				
				dlog(thread,3,"chan_delete = %s\n",chan_delete);
				dlog(thread,3,"chan_update = %s\n",chan_update);
				
				if(chan_delete[0]!='\0')
					straddns(channel_all,chan_delete,sizeof(channel_all));
					
				if(chan_update[0]!='\0'){
					if(channel_all[0]!='\0'){
						straddnc(channel_all,',',sizeof(channel_all));
						straddns(channel_all,chan_update,sizeof(channel_all));
					}else
						straddns(channel_all,chan_update,sizeof(channel_all));
				}

				if(channel_all[0]!='\0'){
                    domysql(thread,"DELETE FROM `orion_chan_users` WHERE `orion_chan_users`.`nick`='%s' AND `orion_chan_users`.`channel` IN(%s)",cs->nick,channel_all);
					domysql(thread,"DELETE `orion_chan_users` FROM `orion_chan_users` LEFT OUTER JOIN `orion_cs_core` ON (`orion_cs_core`.`botnick`=`orion_chan_users`.`nick` AND `orion_cs_core`.`channel`=`orion_chan_users`.`channel`) WHERE `orion_cs_core`.`botnick` IS NOT NULL AND `orion_chan_users`.`channel` IN(%s)",channel_all);
					domysql(thread,"DELETE `orion_cs_akick`,`orion_ms_core` FROM `orion_cs_akick` LEFT OUTER JOIN `orion_ms_core` ON (`orion_cs_akick`.`channel`=`orion_ms_core`.`receiver`) WHERE `orion_cs_akick`.`channel` IN (%s)",channel_all);
				}
				
				if(chan_delete[0]!='\0')
					domysql(thread,"DELETE FROM `orion_cs_core` WHERE `channel` IN (%s)",chan_delete);
				
				if(chan_update[0]!='\0')
					domysql(thread,"UPDATE `orion_cs_core` SET "
							"`botnick`=NULL,`serv`='',`founder`=NULL,`successor`=NULL,`email`='',`settings`='',`regdate`='',`description`='',`mlock_positive`='',"
							"`mode`=REPLACE(`mode`,'r',''),`mlock_negative`='',`mlock_limit`='',`mlock_key`='',`mlock_flood`='',`url`='',`alimit`='',`flags`='',"
							"`welcome`='',`reason`='',`last_used`='',`mlock_redirect`='',`expire`='',`maxmemos`='',"
							"`cs_set`='',`cs_autodeop`='',`cs_autohalfop`='',`cs_autoop`='',`cs_autoprotect`='',`cs_autovoice`='',"
							"`cs_nojoin`='',`cs_signkick`='',`cs_acclist`='',`cs_accchange`='',`cs_akick`='',`cs_ban`='',`cs_banme`='',"
							"`cs_cclear`='',`cs_getkey`='',`cs_halfop`='',`cs_halfopme`='',`cs_info`='',`cs_kick`='',`cs_kickme`='',`cs_invite`='',"
							"`cs_opdeop`='',`cs_opdeopme`='',`cs_protect`='',`cs_protectme`='',`cs_topic`='',`cs_unban`='',`cs_voice`='',"
							"`cs_voiceme`='',`cs_memo`='',`cs_botassign`='',`cs_badwords`='',`cs_fantasia`='',`cs_greet`='',`cs_nokick`='',"
							"`cs_say`='',`bs_set`='-1',`bs_caps_ttb`='-1',`bs_caps_min`='-1',`bs_caps_per`='-1',`bs_flood_ttb`='-1',`bs_flood_ln`='-1',`bs_flood_secs`='-1',`bs_repeat_ttb`='-1',`bs_repeat`='-1',"
							"`bs_colors`='-1',`bs_underlines`='-1',`bs_reverses`='-1',`bs_badwords`='-1',`bs_bolds`='-1'"			
	
						" WHERE `channel` IN (%s)",chan_update);
				
			}
			/* free result */
			mysql_free_result_myr(getSQL[1].res);
			
			/* free Quotes-Array */
			mysql_free_quotes(thread);
	
			if(m->UseWhowas)
				domysql(thread,"DELETE FROM `orion_core_condata_log` WHERE `localtime` <= '%d'",time(NULL)-m->KeepWhowasLog);
			
			/* domysql(thread,"DELETE FROM `orion_core_glines` WHERE `duration` <= '%d' AND `duration`!='0'",gettime); */
			domysql(thread,"DELETE `orion_os_szlines`,`orion_os_sqlines`,`orion_core_glines` FROM `orion_os_szlines` LEFT OUTER JOIN `orion_os_sqlines` ON (`orion_os_sqlines`.`duration`=`orion_os_szlines`.`duration`) LEFT OUTER JOIN `orion_core_glines` ON (`orion_core_glines`.`duration`=`orion_os_szlines`.`duration`) WHERE `orion_os_szlines`.`duration` <= '%ld' AND `orion_os_szlines`.`duration`!='0'",gettime);
			domysql(thread,"DELETE FROM `orion_core_lines` WHERE `duration` <= '%ld' AND `duration`!='0' AND `duration`!=''",gettime);
			
			/* If we have dual encryption */
			if(m->NewEncrypt){
				int counted_old_encryption = stoi(mysql_sel_var(thread,"SELECT count(1) FROM `orion_ns_core` WHERE ~`settings`&%d",NS_NEW_ENCRYPTION));
				if(counted_old_encryption==0){
					MOD_ERROR ModErr = MOD_ERR_OK;
					
					ModErr = OrionUnloadModule(thread,_dynadd("enc_%s",m->encrypt),DO_UNLOAD);
					if(ModErr == MOD_ERR_OK)
						ModErr = OrionUnloadModule(thread,_dynadd("enc_%s",m->NewEncrypt),DO_UNLOAD);
						
					if(ModErr == MOD_ERR_OK){
						zero_config_values(thread);
						update_config(thread,"services");
						if(proof_config(thread)==0){
							do_global(thread,m->servername,"  * ERROR: Reloading Config failed ...");
							dlog(thread,0,"  * ERROR: Reloading Config failed ...");
						}
						
						ModErr = OrionLoadModule(thread,_dynadd("enc_%s",m->encrypt)).ModErr;
	
						if(ModErr != MOD_ERR_OK){
							dlog(thread,0,"  *  ERROR: Loading Encryption Module (Check the Config!)...\n");
							dlog(thread,0,"  *  ERROR: %s\n",ModuleError(ModErr));
							_orion_exit();
						}
						
						do_logchan(thread,"Encryption",NULL,NULL,NULL,"NEW Encryption settings are now running!");
						domysql(thread,"UPDATE `orion_ns_core` SET `settings`=`settings`&~%d",NS_NEW_ENCRYPTION);
					}
				}
			}
			/* **************************** */
			
			if(m->NSEmailReg)
				domysql(thread,"DELETE FROM `orion_ns_request` WHERE `reqtime` <= '%ld' AND `reqtime`!='0' AND `reqtime`!=''",reqexpire);
			
			ExpireCheckTime=time(NULL);
		}

/* P8 */if(LastNickCheck+LastNickCheckDelay<=time(NULL) && !DuringServerlink){
			time_t WarnTime = time(NULL)-LastNickCheckDelay;
			Users *user = NULL;
			
			for(user = users; user; user = user->next){
                if(user->ns_warntime<=WarnTime && user->ns_warntime>0){
					if(getUline(thread,user->server)!=NULL)
						continue;

					if(user->faketype == FAKETYPE_RELEASEUSER)
						do_kill(thread,ns->nick,user->nick,"Nickname released from a requested recover");

					else if((user->settings&NS_SET_KILLPROTECT && user->ns_warntime<=(time(NULL)-60)) ||
						   (m->NSQuickKill>0 && user->settings&NS_SET_KILL_QUICK && user->ns_warntime<=(time(NULL)-m->NSQuickKill)) ||
						   (m->NSImmedKill>0 && user->settings&NS_SET_KILL_IMMED && user->ns_warntime<=(time(NULL)-m->NSImmedKill))){
						if(IRC.SvsNick){
							char number[GUEST_NUMBER_LEN+1];
							char newnick[MAX_NICK_LEN*2];

							bzero(&number,sizeof(number));
							bzero(&newnick,sizeof(newnick));
							randomnumber(number,GUEST_NUMBER_LEN);

							dynncpy(newnick,m->NSGuestNickPrefix,sizeof(newnick));
							straddns(newnick,number,sizeof(newnick));
							strclean(newnick);

							/* Change his nick to GuestXXX.. */
							while(GetUser(newnick)!=NULL){
								bzero(&number,sizeof(number));
								bzero(&newnick,sizeof(newnick));
								randomnumber(number,GUEST_NUMBER_LEN);

								dynncpy(newnick,m->NSGuestNickPrefix,sizeof(newnick));
								straddns(newnick,number,sizeof(newnick));
								strclean(newnick);
							}

							do_svsnick(thread,ns->nick,user->nick,newnick);
							
						}else{
							do_kill(thread,ns->nick,user->nick,"Not Identified");
						}
					}
				}
			}

			/* free Quotes-Array */
			mysql_free_quotes(thread);
			LastNickCheck=time(NULL);
		}
#endif
        
		/* If we want to replay a szenario from a log, we take the log as input file */
		if(debugbylog){
			char line[BUFSIZE];
			char *readSuccessful = NULL;

			bzero(&line,sizeof(line));

			do{
				readSuccessful = fgets(line,sizeof(line)-1,InputLog);
			}while(line[0]!='>' && readSuccessful);

			if(readSuccessful != NULL){
            	dynncpy(thread->inbuf,&line[2],sizeof(thread->inbuf));
                bytes_read = dynlen(thread->inbuf);
			}else{
				dlog(thread,0,"\nEnd of File reached\n");
				printf("\nEnd of File reached\n");
			}
		}

/* Read from Socket */
#ifdef USE_THREADS // at the moment it's the same
/* P9 */else
			bytes_read = (int) (long) sgets2(thread->inbuf, sizeof(thread->inbuf), thread);

		if ((bytes_read > 0) || (bytes_read < (-1))) {
			bzero(&thread->buf,sizeof(thread->buf));
			dynncpy(thread->buf,thread->inbuf,MAX_IRCD_MESSAGE_LEN);
			strclean(thread->buf);

			irc_check_command(thread,thread->buf);
		}
#else
/* P9 */else
			bytes_read = (int) (long) sgets2(thread->inbuf, sizeof(thread->inbuf), thread);

		if ((bytes_read > 0) || (bytes_read < (-1))) {
        	bzero(&thread->buf,sizeof(thread->buf));
        	dynncpy(thread->buf,thread->inbuf,MAX_IRCD_MESSAGE_LEN);
        	strclean(thread->buf);

        	irc_check_command(thread,thread->buf);
        }
#endif

#ifndef USE_THREADS
		if(m->UseWebForm){
			// copy it
			read_fds = master;
    		struct timeval tv;

    		tv.tv_sec = 0;
    		tv.tv_usec = 0;

            int selection = select(fdmax+1, &read_fds, NULL, NULL, &tv);
            // We do nothing until the timeout hits us
			if(selection == -1){ // select produced an error
				dlog(WebFormSocketThread,0,"  *  ERROR: WebForm - for select()\n");
				exit(1);
			}
			else if(selection>0){ // File descriptors found
				//dlog(WebFormSocketThread,0," [*] WebForm - Server-select() is OK...\n");

 				// run through the existing connections looking for data to be read
				for(SockIterator = 0; SockIterator <= fdmax; SockIterator++){
                	//dlog(WebFormSocketThread,0," LOOP: SockIterator=%d; fdmax=%d\n",SockIterator,fdmax);
					if(FD_ISSET(SockIterator, &read_fds)){ // we got one...
						WebFormSocketThread->Sock = SockIterator;
						Socket *s = FindWebSocket(SockIterator);
						if(s == NULL)
							s = addWebSocket(SockIterator);

						if(s->Sock == WebFormSocketThread->MSock){
							// handle new connections
#ifdef _WIN32
							addrsize = (int)sizeof(clientaddr);
#else
							addrsize = (unsigned int)sizeof(clientaddr);
#endif
							if((s->Sock = accept(WebFormSocketThread->MSock, (struct sockaddr *)&clientaddr, &addrsize)) == -1){
								dlog(WebFormSocketThread,0,"  *  ERROR: WebForm - Server-accept() error\n");
							}
							else{
								//dlog(WebFormSocketThread,0," [*] WebForm - Server-accept() is OK...\n");
								FD_SET(s->Sock, &master); // add to master set
								if(s->Sock > fdmax){ // keep track of the maximum
									fdmax = s->Sock;
								}
#ifndef _WIN32
								save_fd = fcntl( s->Sock, F_GETFL );
								save_fd |= O_NONBLOCK;
								fcntl( s->Sock, F_SETFL, save_fd );
#else
								s->Sock =  orion_socksetnonb(save_fd);
#endif

								s->Ip = clientaddr.sin_addr;
								dlog(WebFormSocketThread,0," [*] WebForm - New connection from %s on socket %d\n",inet_ntoa(s->Ip), s->Sock);
								do_logchan(thread,"WebForm",NULL,NULL,NULL,"New connection from %s on socket %d",inet_ntoa(s->Ip), s->Sock);

								if(WebCheckIp(s)==false)
									WebSocketClose(WebFormSocketThread,s);
								/* Check if Ip was blacklisted (not existing atm) */
								//else if(WebFormBlackList(s->Ip))
								//	WebSocketClose(WebFormSocketThread,s);
							}
						}

						else{
							// handle data from a client
							web_read = (int) (long) sgets2(WebFormSocketThread->inbuf, sizeof(WebFormSocketThread->inbuf), WebFormSocketThread);
							//printf("inbuf: %s length: %d\n",WebFormSocketThread->inbuf, (int)dynlen(WebFormSocketThread->inbuf));
							
							if ((web_read > 0) || (web_read < (-1))) {	// Read from Socket
								// we got some data from a client - we send it back
			        			bzero(WebFormSocketThread->buf,sizeof(WebFormSocketThread->buf));
			        			dynncpy(WebFormSocketThread->buf,WebFormSocketThread->inbuf,513);

			        			// Send to Interpreter
			        			web_check_command(WebFormSocketThread,WebFormSocketThread->buf);
							}
							else{
								// got error or connection closed by client
								//printf("joined web_read <= 0: %d\n", web_read);
								if(web_read == 0)
									// connection closed
									dlog(WebFormSocketThread,0," [*] WebForm - Socket %d hung up\n", WebFormSocketThread->Sock);
								else
									dlog(WebFormSocketThread,0,"  *  ERROR: WebForm - Receive error\n");

								WebSocketClose(WebFormSocketThread,s);
							}
						}
					}
				}
			}
		}
#endif

/** Last we manage Traffic modes here **/
		if(TrafficCalcTime<=time(NULL)+1){
            time_t timediff = time(NULL) - TrafficCalcTime;
			m->TrafficIn2_bps = m->TrafficIn_bps / timediff;
			m->TrafficOut2_bps = m->TrafficOut_bps / timediff;
			m->TrafficIn_bps  = 0;
			m->TrafficOut_bps = 0;
			
			TrafficCalcTime = time(NULL);
		}
        
/** We want to be sure, that we dumped all shit (not a performance loss at all) **/
		mysql_free_quotes(thread);
		
/** End of Processes - excute them all again - since the Loop breaks (User Interrupt/SegFault) **/
	}
	orion_exit(IRCThread);
	return 0;
}
